// $Id$
//
// $Log$
//

import java.awt.*;
import java.util.*;
import java.applet.Applet;

public class ChancoButton extends Applet implements Runnable {
    int frameNumber = 1;
    String windowClass;
    String buttonText;
    String windowTitle;
    int requestedWidth = 0;
    int requestedHeight = 0;
    Button button;
    Thread windowThread;
    boolean pleaseCreate = false;

    TextField user,sleep,server;
    String host,port;

    public void init() {
        windowClass = "JavaChanco";
        buttonText = "Start";
        port = getParameter("PORT");
        host = getParameter("HOST");

        String windowWidthString = getParameter("WINDOWWIDTH");
        if (windowWidthString != null) {
            try {
                requestedWidth = Integer.parseInt(windowWidthString);
            } catch (NumberFormatException e) {
                //Use default width.
            }
        }

        String windowHeightString = getParameter("WINDOWHEIGHT");
        if (windowHeightString != null) {
            try {
                requestedHeight = Integer.parseInt(windowHeightString);
            } catch (NumberFormatException e) {
                //Use default height.
            }
        }

        Panel p0 = new Panel();
        p0.setLayout(new GridBagLayout());
        Constrain c = new Constrain(p0);

        c.add( new Label("Server"),0,0,1,1,5,5,0,5);
        server = new TextField();
        c.add( server,1,0,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,0,0,5);

        c.add( new Label(Resource.OptionsDialog_user),0,1,1,1,5,5,0,5);
        user = new TextField();
        c.add( user,1,1,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,0,0,5);

        c.add( new Label(Resource.OptionsDialog_sleep),0,2,1,1,5,5,0,5);
        sleep = new TextField();
        c.add( sleep,1,2,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,0,0,5);

        setLayout(new BorderLayout(0,15));
        add("Center",p0);
        add("East", button = new Button(buttonText));
        button.setFont(new Font("Helvetica", Font.PLAIN, 14));

        user.setText(getParameter("USER"));
        sleep.setText(getParameter("SLEEP"));
        server.setText(host+":"+port);
        server.setEditable(false);
    }

    public void start() {
        if (windowThread == null) {
            windowThread = new Thread(this, "Bringing Up " + windowClass);
            windowThread.start();
        }
    }

    public synchronized void run() {
        Class windowClassObject = null;
        Class tmp = null;
        String name = null;

        //Everything's OK. Wait until we're asked to create a window.
        while (windowThread != null) {
            while (pleaseCreate == false) {
                try {
                    wait();
                } catch (InterruptedException e) {
                }
            }

            //We've been asked to bring up a window.
            pleaseCreate = false;
            try {
               String[] args = {user.getText(),host,port,sleep.getText()};
               JavaChanco j = new JavaChanco();
               j.main(args);
            } catch (Exception e) {
                button.disable();
                return;
            }
        }
    }

    public synchronized boolean action(Event event, Object what) {
        if (event.target instanceof Button) {
            //signal the window thread to build a window
            pleaseCreate = true;
            notify();
        }
        return true;
    }
}
