#include <stdlib.h>
#include <stdio.h>

#include <syslog.h>

#include "config.h"

/*
 * Automatically adding new groups based on a pattern file.
 */

int main(int argc, char **argv)
{
    int result = 0;
    int *rbv = NULL;
    int i;

    if(init_watermark(cfg.remotehost, cfg.workdir) <= 0) {
        syslog(LOG_ERR, "Failed reading %s.watermark", cfg.remotehost);
        result = 3;
    }
    else {

        /*
         * Connect.
         */
        rbv = rio_connect();

        /*
         * Query remote's date and time.
         * TODO: Optionally force local (rbv == NULL).
         */
        if(get_datim(rbv, &cfg.nextdate, &cfg.nexttime, cfg.remotewait)) {
        }

        /*
         * Send posts.
         */
        send_posts(rbv, cfg.remotehost);

        /*
         * Query lists.
         */
        get_lists(rbv, cfg.mode, cfg.remotehost, cfg.listpattern,
                  cfg.lastdate, cfg.lasttime, cfg.remotewait);


        /*
         * Note that we can't start multiple threads on single session
         * connections, because the server remains in a group unless
         * switched to another. Group switching may degrade performance.
         */
        for(i = 0; i < cfg.nthreads; i++)
            suck_groups(cfg.remotehost);

        /*
         * Show progress, either in text mode or through a socket
         * feeding an UIL or Java client.
         */


        /*
         * Disconnect.
         */

        if(exit_watermark()) {
            syslog(LOG_ERR, "Failed updating %s.watermark", cfg.remotehost);
            result = 3;
        }
    }

}
