/*
 * This is a consumer plug-in
 */

#include <readconf.h>

typedef struct {
    char filterfile[_MAX_PATH];
} CONFIG;

static ENVTABLE et[] = {
    { cfg.workdir    , "CHANGIWORKDIR"   , "", 0 },

    { cfg.spooldir   , "CHANGISPOOLDIR"  , "spool", 1 },

    { cfg.filterfile , "CHANXFILTERFILE" , "filter.cf", 3 },
    { cfg.filtermacro, "CHANXFILTERMACRO", "cxdrop.cmd", 3 },
    { cfg.filterover , "CHANXFILTEROVER" , "overfilt.cmd", 3 },

    { cfg.remoteport , "CHANXNEWSPORT"   , "nntp", 2 },
    { cfg.localaddr  , "CHANGILOCALHOST" , "127.0.0.1", 2 },
    { cfg.localport  , "CHANGINEWSPORT"  , "nntp", 2 },

    { NULL           , NULL              , "", 0 }
};

CONFIG cfg;

/************************************************************************
*
* CupInit
*
* Should return the supported level. Currently we are at level 0.
* Returns -1 in case of any error.
*
************************************************************************/
int _Export _System CupInit(int argc, char **argv)
{
    read_conf(et);
}

/************************************************************************
*
* CupExit
*
* Clean up.
*
************************************************************************/
int _Export _System CupExit()
{
}

/************************************************************************
*
* CupConsumeArticle
*
* Process the given article.
*
************************************************************************/
int _Export _System CupConsumeArticle()
{
}


/************************************************************************
*
* CupDropInit
*
* This will not be called by Catchup itself, but may be used by other
* plug-ins, which do not support their own drop processing.
*
************************************************************************/
int _Export _System CupDropInit(char **header)
{
}

/************************************************************************
*
* CupDropExit
*
* Clean up.
*
* This will not be called by Catchup itself, but may be used by other
* plug-ins, which do not support their own drop processing.
*
************************************************************************/
int _Export _System CupDrop(char **header)
{
}

/************************************************************************
*
* CupDrop
*
* This will not be called by Catchup itself, but may be used by other
* plug-ins, which do not support their own drop processing.
*
************************************************************************/
int _Export _System CupDrop(char **header)
{
}
