#ifndef CONFIG_H
#define CONFIG_H

typedef struct {
    char remotehost[128];
    char remoteaddr[128];
    char remoteport[128];
    char workdir[_MAX_PATH];
    char pidfile[_MAX_PATH];
    char listpattern[128];
    int  nthreads;
    long lastdate;
    long lasttime;
    long nextdate;
    long nexttime;
    long remotewait;
    unsigned long mode;
    int canpost;
} CONFIG;

extern CONFIG cfg;

/*----------------------------------------------------------------------*/
/*  Logging flags                                                       */
/*----------------------------------------------------------------------*/
#define LOG_TELE        0x00000001L
#define LOG_INTER       0x00000002L
#define LOG_DROP        0x00000004L
#define LOG_POST        0x00000008L
#define LOG_CONFIG      0x00000010L

#define DOLOG(x)    ((cfg.logflg & (unsigned long)(x)) != 0)

/*----------------------------------------------------------------------*/
/*  Mode flags                                                          */
/*----------------------------------------------------------------------*/
#define MOD_NGLIST      0x00000001
#define MOD_POST        0x00000002
#define MOD_QUERY       0x00000004
#define MOD_READER      0x00000008
#define MOD_SLAVE       0x00000010
#define MOD_BATCH       0x00000080
#define MOD_OMITUPD     0x00000100
#define MOD_DTLOCAL     0x00000200
#define MOD_TYPE        0x00000400
#define MOD_DOSFILE     0x00000800
#define MOD_ACTLIST     0x00001000
#define MOD_DSTLIST     0x00002000
#define MOD_SUBLIST     0x00004000
#define MOD_NEWGROUPS   0x00008000
#define MOD_NONEWNEWS   0x00010000
#define MOD_DROPSAVE    0x00020000
#define MOD_FILTER      0x00040000
#define MOD_XOVER       0x00080000
#define MOD_TEST        0x00100000

#define DOMOD(x)    ((cfg.mode & (unsigned long)(x)) != 0)



#endif
