#include "depdir.h"

typedef struct {
    void *dhdl;
    char jobdir[_MAX_PATH];
} JOBENTRY;

/************************************************************************
*
* CupNextPost
*
* Queries the next post waiting for a given remote.
*
************************************************************************/
void * _Export _System CupNextPost(LINBUF *head, LINBUF *body)
{
    static int initialized = 0;
    static void *dhdl = NULL;
    char jobdir[_MAX_PATH];

    if(request_mutex(&mux, MUTEXWAIT))
        return(-1);

    /*
     * Get first entry.
     */
    if(!initialized) {
        strcpy(jobdir, cfg.spooldir);
        domain_path(jobdir, sysname, NULL);
        if((cp = strrchr(jobdir, '\\')) == NULL)
            remotenode = strdup(sysname);
        else {
            *cp++ = '\0';
            remotenode = strdup(cp);
        }
        sprintf(tpl, "%s\\C.%.8s*", jobdir, remotenode);

        if((dhdl = FindFirstEntry(tpl, cmdname)) != NULL) {
            /*
             * Read article into an array.
             */
            read_header(fp, head);
            read_article(fp, body);
        }
    }

    /*
     * Get remaining entries.
     */
    else if(dhdl) {
        if(FindNextEntry(dhdl, cmdname) == 0) {
            /*
             * Read article into an array.
             */
            read_header(fp, head);
            read_article(fp, body);
        }
        else
            dhdl = NULL;
    }

    release_mutex(mux);

    return(result);
}

/************************************************************************
*
* CupPosted
*
* Informs us wether the post has been successful or not. The exact
* nntp error code is supplied, so that we can decide, wether we
* will remove that post or keep it for later retries.
*
************************************************************************/
int _Export _System CupPosted(void *hdl, int result)
{

}
