/************************************************************************
*
*
*
************************************************************************/
int get_a_list(void *rbv, char *listcmd, char *listname, long maxwait)
{
    if(rio_transact(rbv, listcmd, buf, maxwait))
        result = -1;
    else if(buf[0] != '2')
        result = -1;

    for (;;) {
        if(SoStreamBufRecv(buf, MAX_BUFSIZ, rbv, maxwait) <= 0) {
            items = -1;
            break;
        }

	if (!strcmp(buf, "."))
            break;
        items++;
        if(fprintf(fp, "%s\n", buf) <= 0) {
            syslog(LOG_ERR, "%s", _strerror(filename));
            items = 0;
            break;
        }
    }
}

typedef struct {
    long mask;
    int  parmtyp;
    char *report;
    char *extend;
    char *cmd;
} LISTPARM;

LISTPARM lipa[] = {
    { MOD_NGLIST   , 1, "newsgroup descriptions", ".newsgroups"   , "LIST NEWSGROUPS"           },
    { MOD_ACTLIST  , 1, "active newsgroups",      ".active"       , "LIST ACTIVE"               },
    { MOD_DSTLIST  , 1, "distributions",          ".distributions", "LIST DISTRIBUTIONS"        },
    { MOD_SUBLIST  , 1, "subscriptions",          ".subscriptions", "LIST SUBSCRIPTIONS"        },
    { MOD_NEWGROUPS, 2, "new newsgroups",         ".newgroups"    , "NEWGROUPS %06lu %06lu GMT" }
};

#define NUMLISTS    (sizeof(lipa) / sizeof(lipa[0]))

/************************************************************************
*
*
*
************************************************************************/
int get_lists(void *rbv, long flags, char remotehost, char *pattern,
              long ldate, long ltime, long maxwait)
{
    for(i = 0; i < NUMLISTS; i++) {
        if((flags & lipa[i].mask) == 0)
            continue;
        switch(lipa[i].parmtyp) {
        case 1:
            strcpy(cmd, lipa[i].cmd);
            if(pattern && *pattern) {
                strcat(cmd, " ");
                strcat(cmd, pattern);
            }
            break;
        case 2:
            sprintf(cmd, "%s %06lu %06lu GMT", ldate, ltime);
            break;
        default:
            strcpy(cmd, lipa[i].cmd);
            break;
        }
        domain_path(pathname, remotehost, lipa[i].extend);
        get_a_list(rbv, lipa[i].cmd, pathname, maxwait);
    }
}
