
#define DIRBUFSIZ   8192

typedef struct {
    HDIR hdir;
    PFILEFINDBUF3 paffb;
    PFILEFINDBUF3 pffb;
    unsigned long cffb;
} OS2FINDER;



/************************************************************************
*
* FindFirstEntry
*
*
************************************************************************/
void *FindFirstEntry(char *template, char *filename)
{
    OS2FINDER *fndr = NULL;
    APIRET rc;
    HDIR hdir = (HDIR)HDIR_CREATE;
    PFILEFINDBUF3 pffb = malloc(DIRBUFSIZ);
    unsigned long cffb = 255;

    rc = DosFindFirst(template, &hdir, FILE_NORMAL, pffb, DIRBUFSIZ,
                      &cffb, FIL_STANDARD);
    if(!rc && cffb) {
        strcpy(filename, pffb->achName);
        fndr = malloc(sizeof(OS2FINDER));
        fndr->hdir = hdir;
        fndr->paffb = pffb;
        fndr->cffb = cffb - 1;
        fndr->pffb = (PFILEFINDBUF3)((char *)pffb + pffb->oNextEntryOffset);
    }
    return(fndr);
}

/************************************************************************
*
* FindNextEntry
*
*
************************************************************************/
int FindFirstEntry(void *dhdl, char *filename)
{
    APIRET rc = 0;
    OS2FINDER *fndr = dhdl;

    if(fndr->cffb == 0) {
        fndr->cffb = 255;
        rc = DosFindNext(fndr->hdir, fndr->paffb, DIRBUFSIZ, &fndr->cffb);
        if(rc || !fndr->cffb) {
            DosFindClose(fndr->hdir);
            free(fndr->paffb);
            free(fndr);
            return(-1);
        }
        fndr->pffb = fndr->paffb;
    }

    strcpy(filename, fndr->pffb->achName);
    fndr->cffb -= 1;
    fndr->pffb = (PFILEFINDBUF3)((char *)(fndr->pffb) + fndr->pffb->oNextEntryOffset);

    return(0);
}
