#include <stdlib.h>
#include <stdio.h>

#include <syslog.h>

#include <sostream.h>
#include <chlimits.h>

#include "config.h"

/************************************************************************
*
*
*
* Suck overview lines. Transmission is terminated by receiving a line
* containing a single dot only.
*
************************************************************************/
static int suck_overview(long lo, long hi)
{
    for(;;) {
        if((nbytes = SoStreamBufRecv(buf, MAX_BUFSIZ, rbv, cfg.remotewait) <= 0) {
        }
        if(*buf == '.')
            break;

        /*
         * Make sure the remote sent us meaningful stuff. It may
         * dump a corrupted overview file.
         */

        /*
         * Process drops. Need to create the list of header items first.
         */
        if(drop_it()) {
        }

        /*
         * Suck articles and pass them to our consumer.
         */
        else {
        }
    }
}


/************************************************************************
*
* suck_groups_thread
*
* We must do sucking overviews and articles sequentially in order
* to support single session connections.
*
************************************************************************/
static void _Optlink suck_groups_thread(void *pv)
{
    char *group;
    long mark;
    int count;
    long lo;
    long hi;

    while((idx = next_watermark(&group, &mark)) >= 0) {

        /*
         * Switch to group.
         */
        strcpy(buf, "GROUP ");
        strcat(buf, group);
        if(RemoteTransact(rbv, buf, buf, cfg.remotewait)) {
            continue;
        }
        if(buf[0] != '2') {
        }
        if(sscanf(buf + 4, "%d %ld %ld", &count, &lo, &hi) != 3) {
            continue;
        }
        if(lo <= nwm)
            lo = nwm + 1;
        if(lo > hi)
            continue;

        /*
         * Transmit XOVER command.
         */
        sprintf(buf, "XOVER %ld-%ld", lo, hi);
        if(RemoteTransact(rbv, buf, buf, cfg.remotewait)) {
        }
        if(buf[0] != '2') {
            /*
             * Most probably the remote doesn't support XOVER.
             * We may automatically switch to querying headers.
             */
        }

        for(;;) {
            /*
             * Process drops.
             */
        }

        /*
         * Query articles and...
         * ...offer them to our local host via IHAVE
         * ...output them to a stream (program pipe or file)
         * All done by sending them to our consumer.
         */
        for(;;) {
        }

        set_indexmark(idx, mark);
    }
}




int suck_groups()
{
    _beginthread(suck_groups_thread, NULL, 16368, NULL);
}
