#ifndef CHANX_H
#define CHANX_H

/*----------------------------------------------------------------------*/
/* Copyright (c) 1996 by Harald Kipp. All rights reserved.              */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/* This software has been inspired by several UNIX programs and their   */
/* OS/2 ports:                                                          */
/*                                                                      */
/* slurp - written 1992/93 by Stephen Hebditch and ported to OS/2 by    */
/* Jochen Friedrich.                                                    */
/*                                                                      */
/* nntpxfer - written by Brian Kantor                                   */
/*                                                                      */
/* nntpget - author unknown                                             */
/*                                                                      */
/* nntpclnt - Copyright 1992 by Stan Barber                             */
/*                                                                      */
/* souper - written by Chin Huang                                       */
/* Send bug reports to                                                  */
/*                                                                      */
/*      harald@os2point.ping.de                                         */
/*                                                                      */
/*----------------------------------------------------------------------*/

/*
 * $Id$
 */

struct artlink {
    struct artlink *next;
    char *line;
};

/*----------------------------------------------------------------------*/
/*  main thread conversation                                            */
/*----------------------------------------------------------------------*/
extern int get_time(void *rbv);
extern int send_posts(void *rbv);
extern int get_lists(void *rbv);
extern int getnnn(void *rbv);

extern int catchup(void *rbv);

/*----------------------------------------------------------------------*/
/*  multithreaded conversations                                         */
/*----------------------------------------------------------------------*/
extern int full_stop;
extern void collect_ids(void);
extern void collect_arts(void);
extern void collect_overview(void);
extern void collect_xarts(void);

/*----------------------------------------------------------------------*/
/*  id pool                                                             */
/*----------------------------------------------------------------------*/
extern int init_idpool(void);
extern void exit_idpool(void);
extern void add_id(char *id, int filter);
extern int get_id(char *id);
extern int offer_id(void *rbv, char *id);

/*----------------------------------------------------------------------*/
/*  art pool                                                            */
/*----------------------------------------------------------------------*/
extern int init_artpool(void);
extern void exit_artpool(void);
extern void add_artpool(char *item);
extern int get_artpool(char *group, long *artnum);

/*----------------------------------------------------------------------*/
/*  art spewing                                                         */
/*----------------------------------------------------------------------*/
int init_artspew(void);
void exit_artspew(void);
int spew_block(char *buf, long bufsiz);
int spew_hb(char *headline[], long hsize, char *body, long bsize);

/*----------------------------------------------------------------------*/
/*  remote                                                              */
/*----------------------------------------------------------------------*/
extern int *remote_connect(void);
extern long receive_header(int *rbv, char **headbuf, size_t *sizep, char *hdrline[]);
extern long receive_block(int *rbv, char **bodypp, size_t *sizep);

extern int authenticate(void *rbv, char *buf);

/*----------------------------------------------------------------------*/
/*  filter                                                              */
/*----------------------------------------------------------------------*/
extern int read_drop(void);
extern int do_drop(struct artlink *ar);
extern int new_drop(char *headline[]);
extern int over_drop(char *group, char *overline);
extern void drop_msgid(char *headline[]);
extern void drop_artnum(char *group, long artnum, char *headline[]);
extern void drop_overview(char *group, char *overline);

#endif
