#ifndef IDTREE_H
#define IDTREE_H

/*
 * Balance states
 */
typedef enum {
    LEFTGROWN,  /* left subtree has grown  */
    BALANCED,   /* subtrees are balanced   */
    RIGHTGROWN  /* right subtree has grown */
} BALSTAT;

/*
 * Node header structure
 */
typedef struct _NODE {
    struct _NODE *pLLink;   /* pointer to smaller item values */
    struct _NODE *pRLink;   /* pointer to greater item values */
    BALSTAT status;         /* balance status                 */
} NODE, *PNODE;

int id_tree_insert(NODE **ppRoot, char *id);
void id_tree_destroy(NODE *pTree);

#endif
