#ifndef CONFIG_H
#define CONFIG_H

/*
 * $Id: config.h,v 1.1 1997/02/13 11:21:42 oliver Exp $
 */

#if 0
#define MAX_ITEMSIZE    2048    /* max length of a header line */
#define MAX_PCKSTRING   8       /* max length of radixpack result */
#define MAX_NODENAME    32      /* max length of a node name */
#define MAX_DOMAINNAME  128     /* max length of a domain name */
#define MAX_CLPSIZE     128     /* max length of cmd line parameter */
#endif

/*----------------------------------------------------------------------*/
/*  Configuration                                                       */
/*                                                                      */
/*----------------------------------------------------------------------*/
typedef struct {
    char workdir[_MAX_PATH];    /* changi home dir */
    char activefile[_MAX_PATH];
    char expireconf[_MAX_PATH];

    char newsdir[_MAX_PATH];    /* news home directory */
    char overdir[_MAX_PATH];
    char logfile[_MAX_PATH];    /* logfile name */
    char pidfile[_MAX_PATH];    /* process id flag file */
    char historyfile[_MAX_PATH];
    char tempdir[_MAX_PATH];
    char sortcall[_MAX_PATH];   /* sorting program */
    char summary[_MAX_PATH];    /* file to store summary */
    char zapfile[_MAX_PATH];    /* file to store delete commands */
    char logname[128];
    unsigned long logflg;
    long expiresecs;            /* # of seconds to keep articles */
    long forgetsecs;            /* # of seconds to remember ids */
    long timewarp;
    int  ignorexp;
    int  nohistory;
    int  dorebuild;
    int  quitbad;
    int  verbose;
    int  oldindex;              /* use old UUPC compatible index */
    int  cancel;
    int  verify;
    int  noserver;
    int  nooverview;
    int  usepost;
    int  noupdate;
    int  noactive;
    int  normempty;             /* if set, do not remove empty directories */
    int  xcl_time;
    int  xcl_size;
    int  removebad;
    int  rebuildactive;
    int  createactive;
    int  sortactive;
    int  uselastwrite;          /* use last write instead of creation date */
    char copyfrom[_MAX_PATH];   /* 08/20/97 added */
    char expreason[BUFSIZ];
    char groups[BUFSIZ];        /* expire groups */
    char controlport[128];
    char controlhost[128];
} CONFIG;

extern CONFIG cfg;

extern void init_cfg(void);
extern int validate_cfg(void);

/*----------------------------------------------------------------------*/
/*  Logging flags                                                       */
/*----------------------------------------------------------------------*/
#define LOG_FLUSH       0x00000001L
#define LOG_TESTMODE    0x00000002L
#define LOG_EXPIRE      0x00000004L

#define DOLOG(x)    (cfg.logflg & (unsigned long)(x))

#endif

/*
 * $Log: config.h,v $
 * Revision 1.1  1997/02/13 11:21:42  oliver
 * initial revision
 *
 */
