/*
 * This part was stolen by Harald Kipp
 * and is originally
 *
 * Copyright (c) 1983 Eric P. Allman
 * Copyright (c) 1988, 1993
 * The Regents of the University of California.  All rights reserved.
 *
 * Bug reports regarding this modified version should be sent to
 *
 *  harald@os2point.ping.de
 *
 */

const char convtime_rcsid[]="$Id: convtime.c,v 1.1 1997/02/13 11:21:43 oliver Exp $";

#include <stdio.h>
#include <time.h>
#include <ctype.h>

#include <chlimits.h>

#include "expire.h"

/*
**  CONVTIME -- convert time
**
**	Takes a time as an ascii string with a trailing character
**	giving units:
**	  s -- seconds
**	  m -- minutes
**	  h -- hours
**	  d -- days (default)
**	  w -- weeks
**	For example, "3d12h" is three and a half days.
**
**	Parameters:
**		p -- pointer to ascii time.
**		units -- default units if one specified.

**
**	Returns:
**		time in seconds.
**
**	Side Effects:
**		none.
*/
long convtime(char *p, char units)
{
    register time_t t, r;
    register char c;

    r = 0;
    while(*p != '\0' && !isspace(*p)) {
        t = 0;
        while((c = *p++) != '\0' && !isspace(c) && isascii(c) && isdigit(c))
            t = t * 10 + (c - '0');
        if(c == '\0' || isspace(c)) {
            c = units;
            p--;
        }
        switch(c) {
        case 'w':   /* weeks */
            t *= 7;

        case 'd':   /* days */
        default:
            t *= 24;

        case 'h':   /* hours */
            t *= 60;

        case 'm':   /* minutes */
            t *= 60;

        case 's':   /* seconds */
            break;
        }
        r += t;
    }

    return(r);
}

/*
 * $Log: convtime.c,v $
 * Revision 1.1  1997/02/13 11:21:43  oliver
 * initial revision
 *
 */
