#ifndef EXPIRE_H
#define EXPIRE_H

/*
 * $Id: expire.h,v 1.1 1997/02/13 11:21:46 oliver Exp $
 */

/*----------------------------------------------------------------------*/
/* Some globals for statistics                                          */
/*                                                                      */
/*----------------------------------------------------------------------*/
extern long ids_processed; /* Ids of processed active articles excl. remembered */
extern long ids_kept;      /* Ids of active articles not expired */
extern long ids_expired;   /* Ids of expired articles */
extern long files_deleted; /* Article files deleted */
extern long dirs_removed;  /* Group directories removed */
extern long old_dropped;   /* Remembered ids dropped */
extern long old_kept;      /* Remembered ids retained */
extern long bytes_removed; /* Size of removed files */

/*----------------------------------------------------------------------*/
/* Purging articles                                                     */
/*                                                                      */
/*----------------------------------------------------------------------*/
long now;   /* current time (at program start) */

extern int purge_by_history(void);
extern int purge_by_active(void);
extern int purge_by_cancel(void);
extern int test_history(void);

/*----------------------------------------------------------------------*/
/* Misc                                                                 */
/*                                                                      */
/*----------------------------------------------------------------------*/
extern char server_cmd[MAX_BUFSIZ];

extern long convtime(char *p, char units);
extern int scan_groups(char *group);
extern int read_expcnf(char *name);
extern char *grouppath(char *path, char *newsdir, char *group);
extern int is_expired(char **groups, long now, long arrived, long expires,
                      long posted);
extern int parse_historyline(char *line, long *arrived, long *expires,
                long *posted, long *artsize, char **grouplist, char **wipe);
extern int remove_art(char **groups, long artsize);
extern int hist_print(FILE *fp, char *id, long arrived, long expires,
                      long posted, long artsize, char **groups);


#endif

/*
 * $Log: expire.h,v $
 * Revision 1.1  1997/02/13 11:21:46  oliver
 * initial revision
 *
 */
