/*
 * This part was written by Harald Kipp
 *
 * Bug reports to
 *
 *  harald@os2point.ping.de
 *
 */

const char ntsgrps_rcsid[] = "$Id: ntsgrps.c,v 1.1 1997/02/13 11:21:49 oliver Exp $";

#include <windows.h>

#include <stdio.h>

#include <chlimits.h>
#include <nactive.h>

#include "config.h"
#include "expire.h"

/************************************************************************/
/*                                                                      */
/* scan_groups                                                          */
/*                                                                      */
/* Starting from a directory this routine scans all subdirectories for  */
/* article files and adds the found newsgroup to the list of active     */
/* files, if it was not already included.                               */
/*                                                                      */
/* Parameter    Description                                             */
/* ------------ ------------------------------------------------------- */
/* group        Points to the string that specifies the group to be     */
/*              searched for existing subgroups. Normally the caller    */
/*              will set this to an empty string.                       */
/* ------------ ------------------------------------------------------- */
/* Return value Number of new groups added.                             */
/*                                                                      */
/************************************************************************/
int scan_groups(char *group)
{
    long artnum;
    HANDLE hdir;
    WIN32_FIND_DATA ffb;
    BOOL foundnext = TRUE;
    int num_arts = 0;
    long hi = 0, lo = 1;
    char *ngdir = malloc(_MAX_PATH);

    if(*group) {
        if(grouppath(ngdir, cfg.newsdir, group) == NULL) {
            free(ngdir);
            return(0);
        }
        strcat(ngdir, "\\*");
    }
    else
        strcat(strcpy(ngdir, cfg.newsdir), "\\*");

    if( (hdir = FindFirstFile(ngdir, &ffb)) != INVALID_HANDLE_VALUE ) {
        while (foundnext) {
            if(ffb.cFileName[0] != '.') {
                if(ffb.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
                    char *lolevel = malloc(strlen(group) + strlen(ffb.cFileName) + 2);
                    if(*group)
                        strcat(strcat(strcpy(lolevel, group), "."), ffb.cFileName);
                    else
                        strcpy(lolevel, ffb.cFileName);
                    scan_groups(lolevel);
                    free(lolevel);
                }
                else if((artnum = atol(ffb.cFileName)) > 0) {
                    if(hi == 0)
                        lo = hi = artnum;
                    else {
                        if(artnum > hi)
                            hi = artnum;
                        if(artnum < lo)
                            lo = artnum;
                    }
                }
            }
            foundnext = FindNextFile(hdir, &ffb);
        }
        FindClose(hdir);
    }
    if(lo <= hi) {
        char rest;

        if((rest = test_active(group)) == '\0')
            rest = 'y';
        add_active(group, lo, hi, rest, "expire", NULL);
    }
    free(ngdir);

    return (num_arts);
}

/*
 * $Log: ntsgrps.c,v $
 * Revision 1.1  1997/02/13 11:21:49  oliver
 * initial revision
 *
 */
