const char rebuild_rcsid[] = "$Id$";
/*
 * This program was written by Harald Kipp
 *
 * Bug reports should be sent to
 *
 *  harald@os2point.ping.de
 *
 * This module contains routines to rebuild the history
 * database, either in new (hash index) or old format.
 *
 */
/*
 * $Log$
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <syslog.h>
#include <chlimits.h>
#include <xfile.h>

#include "config.h"

/************************************************************************/
/*                                                                      */
/************************************************************************/
int rebuild_memory(char *seqhist)
{
    register char *cp;
    register char *cp1;
    char *line;
    char *last;
    char *lswp;
    char *name;
    FILE *fp;
    FILE *fpt;
    int  addit = (*seqhist == '+');

    /*
     * Before removing the current history try to
     * open the new one.
     */
    if((fp = xfopen(seqhist + addit, "r")) == NULL) {
        syslog(LOG_ERR, "%s", _strerror(seqhist));
        return(-1);
    }

    strcpy(name = malloc(strlen(cfg.historyfile) + 5), cfg.historyfile);
    cp = strrchr(name, '\0');
    strcpy(cp, ".pag");

    if(!addit) {
        if((fpt = xfopen(name, "w")) == NULL)
            syslog(LOG_ERR, "Truncate %s", _strerror(name));
    }
    else {
        if((fpt = xfopen(name, "a")) == NULL)
            syslog(LOG_ERR, "Append %s", _strerror(name));
    }

    line = malloc(MAX_HISTORYLINE);
    last = malloc(MAX_HISTORYLINE);
    memset(last, 0, MAX_HISTORYLINE);
    while(fgets(line, MAX_HISTORYLINE, fp)) {
        cp = line;
        if(*cp != '<') {
            if(DOLOG(LOG_EXPIRE))
                syslog(LOG_DEBUG, "Missing <, skipped bad line");
            continue;
        }
        while(*cp && *cp != '>')
            cp++;
        if(*cp == '\0') {
            if(DOLOG(LOG_EXPIRE))
                syslog(LOG_DEBUG, "Missing >, skipped bad line");
            continue;
        }
        cp1 = ++cp;
        *cp1 = '\0';
        if(line[1] == last[1] && strcmp(line, last) == 0) {
            continue;
        }
        *cp1 = ' ';
        while(*cp && *cp != '\n')
            cp++;
        if(*cp == '\0') {
            if(DOLOG(LOG_EXPIRE))
                syslog(LOG_DEBUG, "Skipped long line");
            continue;
        }
        fputs(line, fpt);
        *cp1 = '\0';
        lswp = last;
        last = line;
        line = lswp;
    }
    fclose(fpt);
    fclose(fp);
    free(line);
    free(last);
    free(name);

    return(0);
}
