/*
 * This part was written by Harald Kipp
 *
 * Bug reports to
 *
 *  harald@os2point.ping.de
 *
 */

const char scangrps_rcsid[] = "$Id: scangrps.c,v 1.1 1997/02/13 11:21:53 oliver Exp $";

#define INCL_DOSFILEMGR
#include <os2.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <nactive.h>

#include "config.h"
#include "expire.h"

/************************************************************************/
/*                                                                      */
/* scan_groups                                                          */
/*                                                                      */
/* Starting from a directory this routine scans all subdirectories for  */
/* article files and adds the found newsgroup to the list of active     */
/* files, if it was not already included.                               */
/*                                                                      */
/* Parameter    Description                                             */
/* ------------ ------------------------------------------------------- */
/* group        Points to the string that specifies the group to be     */
/*              searched for existing subgroups. Normally the caller    */
/*              will set this to an empty string.                       */
/* ------------ ------------------------------------------------------- */
/* Return value Number of new groups added.                             */
/*                                                                      */
/************************************************************************/
int scan_groups(char *group)
{
    long artnum;
    HDIR hdir = (HDIR)HDIR_CREATE;
    PFILEFINDBUF3 paffb = malloc(12288);
    PFILEFINDBUF3 pffb;
    unsigned long cffb = 255;
    APIRET rc;
    int i;
    int num_arts = 0;
    long hi = 0, lo = 1;
    char *ngdir = malloc(_MAX_PATH);

    if(*group) {
        if(grouppath(ngdir, cfg.newsdir, group) == NULL) {
            free(ngdir);
            free(paffb);
            return(0);
        }
        strcat(ngdir, "\\*");
    }
    else
        strcat(strcpy(ngdir, cfg.newsdir), "\\*");

    if((rc = DosFindFirst(ngdir, &hdir, 0x10, paffb, 12288, &cffb, 1)) == 0) {
        while (!rc && cffb) {
            pffb = paffb;
            for(i = 0; i < cffb; i++) {
                if(pffb->achName[0] != '.') {
                    if(pffb->attrFile & 0x10) {
                        char *lolevel = malloc(strlen(group) + strlen(pffb->achName) + 2);
                        if(*group)
                            strcat(strcat(strcpy(lolevel, group), "."), pffb->achName);
                        else
                            strcpy(lolevel, pffb->achName);
                        scan_groups(lolevel);
                        free(lolevel);
                    }
                    else if((artnum = atol(pffb->achName)) > 0) {
                        if(hi == 0)
                            lo = hi = artnum;
                        else {
                            if(artnum > hi)
                                hi = artnum;
                            if(artnum < lo)
                                lo = artnum;
                        }
                    }
                }
                pffb = (PFILEFINDBUF3)(((char *)pffb) + pffb->oNextEntryOffset);
            }
            cffb = 255;
            rc = DosFindNext(hdir, paffb, 12288, &cffb);
        }
        DosFindClose(hdir);
    }
    if(lo <= hi) {
        char rest;

        if((rest = test_active(group)) == '\0')
            rest = 'y';
        add_active(group, lo, hi, rest, "expire", NULL);
    }
    free(paffb);
    free(ngdir);

    return (num_arts);
}

/*
 * $Log: scangrps.c,v $
 * Revision 1.1  1997/02/13 11:21:53  oliver
 * initial revision
 *
 */
