#ifndef ARTRANGE_H
#define ARTRANGE_H

/*
 * $Id$
 */

typedef struct {
    long hwm;   /* high watermark */
    long a;     /* current value */
    int  i;     /* range index of current value */
    int  m;     /* total number of values */
    int  n;     /* number of ranges */
    int  x;     /* size of each limit array */
    long *lo;   /* array of lower limits */
    long *hi;   /* array of upper limits */
} ARTRANGE;

extern int arngset(ARTRANGE *arng, long *arts, int narts, long lo, long hi);
extern void arngfree(ARTRANGE *arng);
extern void arngcpy(ARTRANGE *dst, ARTRANGE *src);
extern long arngfind(ARTRANGE *arng, long artnum);
extern long arngnext(ARTRANGE *arng);
extern long arngprev(ARTRANGE *arng);
extern int  arnginfo(ARTRANGE *arng, long *lo, long *hi, long *hwm);
extern long arnginc(ARTRANGE *arng);


/*
 * $Log: artrange.h,v $
 * Revision 1.1  1997/02/13 11:19:47  oliver
 * initial revision
 *
 */

#endif
