#ifndef _DBM_H

#define _DBM_H


/* dbm.h
 *
 * simple history database manager for UUPC news
 *
 * Author:  Kai Uwe Rommel <rommel@ars.muc.de>
 * Created: Sun Aug 15 1993
 */

/*
 * $Id$
 */

#define DBM_MAGIC       4711



#define DBM_EXT_DBF     ".pag"

#define DBM_EXT_IDX     ".dir"



#define DBM_INSERT	0

#define DBM_REPLACE	1



typedef struct {

    int magic;

    int dbffile;

    int idxfile;

    void *idx;

    FILE *stream;

    char buffer[8192];

    char *value;

} DBM;



typedef struct {

    char *dptr;

    size_t dsize;

} datum;



extern datum nullitem;



extern DBM *dbm_open(const char *name, int flags, int mode);

extern void dbm_close(DBM *db);

extern int dbm_store(DBM *db, datum key, datum val, int flag);

extern int dbm_cancel(DBM *db, datum key);

extern datum dbm_fetch(DBM *db, datum key);

extern datum dbm_firstkey(DBM *db);

extern datum dbm_nextkey(DBM *db);



/*
 * $Log: dbm.h,v $
 * Revision 1.1  1997/02/13 11:19:49  oliver
 * initial revision
 *
 */

#endif /* _HDBM_H */

