#ifndef LRANGE_H
#define LRANGE_H

/*
 * $Id$
 */

typedef struct {
    long *lo;   /* array of lower limits */
    long *hi;   /* array of upper limits */
    int  x;     /* size of each limit array */
    int  n;     /* number of ranges */
} LRANGE;


extern void lrange_new(LRANGE *lrp);
extern void lrange_free(LRANGE *lrp);
extern void lrange_set(LRANGE *lrp, long lo, long hi);
extern void lrange_build(LRANGE *lrp, long *values, int num);
extern long lrange_next(LRANGE *lrp, long value);
extern long lrange_prev(LRANGE *lrp, long value);
extern void lrange_info(LRANGE *lrp, int *num, long *lo, long *hi);


/*
 * $Log: lrange.h,v $
 * Revision 1.1  1997/02/13 11:19:55  oliver
 * initial revision
 *
 */

#endif
