#ifndef NHISTORY_H
#define NHISTORY_H

/*
 * $Id$
 */
/*
 * $Log$
 */

/*
 * Balance states
 */
typedef enum {
    LEFTGROWN,  /* left subtree has grown  */
    BALANCED,   /* subtrees are balanced   */
    RIGHTGROWN  /* right subtree has grown */
} BALSTAT;

/*
 * Node header structure
 */
typedef struct _NODE {
    struct _NODE *pLLink;   /* pointer to smaller item values */
    struct _NODE *pRLink;   /* pointer to greater item values */
    BALSTAT status;         /* balance status                 */
    long    recnum;         /* record number                  */
} NODE, *PNODE;

int avl_insert(NODE **ppRoot, char *id, long recnum);
long avl_find(NODE *pTree, char *id);
void avl_destroy(PNODE pTree);


#endif
