#ifndef NACTIVE_H
#define NACTIVE_H

/*
 * $Id$
 */

extern void debug_active(int enable);
extern void active_maxwait(long maxwait);

extern int init_active(const char *newsdir);
extern void exit_active(void);

extern int new_active(const char *name);

extern int load_active(const char *pathname);
extern int save_active(const char *pathname, int force);

extern int valid_newsgroup(const char *group);

extern char test_active(const char *group);
extern char query_active(const char *group, int *num, long *lo, long *hi);

extern int add_active(char *group, long lo, long hi, char mode, char *who, const char *active_times);
extern int del_active(const char *group, char *who);

extern long inc_active(const char *group);

extern char *next_group(char *group);
extern int get_groupentry(int index, char *info);

extern void set_expiration(char *pattern, long minkeep, long maxkeep);
extern int query_expiration(char *group, long *minkeep, long *maxkeep);

/*
 * $Log: nactive.h,v $
 * Revision 1.1  1997/02/13 11:19:57  oliver
 * initial revision
 *
 */

#endif
