#ifndef SOSTREAM_H
#define SOSTREAM_H

/*----------------------------------------------------------------------*/
/* Copyright (c) 1996 by Harald Kipp. All rights reserved.              */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/* Send bug reports to                                                  */
/*                                                                      */
/*      harald@os2point.ping.de                                         */
/*                                                                      */
/*----------------------------------------------------------------------*/

/*
 * $Id$
 */

#define MAX_SOSTREAMCHUNK   1024
#define MAX_SOSTREAMBUFSIZ  8192
#define MAX_DOMAINNAMESIZ   256

extern int _System SoInitialize(void);

extern int _System SoStreamOpen(void);
extern int _System SoStreamClose(int sock);

extern int _System SoStreamSetServer(const char *service, unsigned short defport);
extern int _System SoStreamConnect(const char *host, const char *service, unsigned short defport);
extern int _System SoStreamAccept(int sock, char *host, long *inaddr);

extern void * _System SoStreamBufCreate(int sock);
extern void _System SoStreamBufDestroy(void *rbv);
extern int _System SoStreamBufGets(char *pline, size_t n, void *rbv);
extern int _System SoStreamBufRecv(char *pline, size_t n, void *rbv, long maxsecs);
extern size_t _System SoStreamBinRecv(char *pblock, size_t n, int s, long maxsecs);

extern int _System SoStreamPuts(int s, const char *line);
extern int _System SoStreamTransact(void *rbv, const char *question, char *answer, long maxsecs);
extern int _System SoStreamBinSend(const char *pblock, size_t n, int s);

extern void _System SoStreamDebug(int enable);

extern long _System SoGetHostAddr(const char *hostname);
extern unsigned short _System SoGetServPort(const char *service, const char *proto);
extern int _System SoGetLocalHost(char *localname, long *localaddr);
extern void _System SoGetRemoteHost(void *from, char *remotename, long *remoteaddr);
extern char * _System SoErrorString(int ec);

extern int SoStreamPrintf(int s, const char *format,...);

#endif
