#ifndef WMLINK_H
#define WMLINK_H

/*
 * $Id$
 */

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _WMLINK {
    struct _WMLINK *next;   /* links next item, last is NULL */
    struct _WMLINK *prev;   /* links previous item, first is NULL */
    char group[256];        /* newsgroup name */
    long last_art;          /* last article number retrieved */
                            /* --- expiration data --- */
    int  days_keep;         /* max age of articles */
    int  arts_keep;         /* max # of articles in group */
    long size_keep;         /* max total kBytes occupied by this group */
} WMLINK;

extern int test_wmlink(const char *hostname);
extern WMLINK *load_wmlink(const char *hostname);
extern int save_wmlink(const char *hostname, const WMLINK *wml);

/* return: new root */
extern WMLINK *add_wmlink(WMLINK *wml, const char *group, WMLINK **wmp);
extern WMLINK *insert_wmlink(WMLINK *wml, WMLINK *wmi);
extern WMLINK *del_wmlink(WMLINK *wml, const char *group);


extern int free_wmlink(WMLINK *wml);

#ifdef __cplusplus
}
#endif

/*
 * $Log: wmlink.h,v $
 * Revision 1.1  1997/02/13 11:20:10  oliver
 * initial revision
 *
 */

#endif
