// $Id$
//
// $Log$
//

import java.awt.*;
import java.io.*;

public class GroupsDialog extends Dialog
   {
   Options options;
   List groupList;
   GroupsThread groupsThread;
   public Button changeButton;
   public Button removeButton;

   GroupsDialog(Frame parent, Options options)
      {
      super(parent, Resource.GroupsDlg_title, false);
      this.options = options;

      Panel p2 = new Panel();
      p2.setLayout(new GridBagLayout());
      Constrain c = new Constrain(p2);

      c.add( new Label(Resource.GroupsDlg_grouplist),0,0,2,1,5,5,0,5);
      c.add( groupList = new List(),0,1,2,1,GridBagConstraints.BOTH,GridBagConstraints.NORTHWEST,1,1,0,5,0,0);

      Panel p1 = new Panel();
      p1.setLayout( new FlowLayout(FlowLayout.LEFT,10,10) );
      p1.add( new Button(Resource.GroupsDlg_add) );
      p1.add( changeButton = new Button(Resource.GroupsDlg_change) );
      changeButton.disable();
      p1.add( removeButton = new Button(Resource.GroupsDlg_remove) );
      removeButton.disable();
      p1.add( new Button(Resource.GroupsDlg_quit) );

      add( "Center", p2);
      add( "South", p1);

      this.pack();
      Rectangle b = parent.bounds();
      reshape( b.x + b.width/2 - 250,
               b.y + b.height/2 - 240,
               500,
               480 );
      groupsThread = new GroupsThread(options, groupList); groupsThread.start();
      }

   public boolean action( Event evt, Object what )
      {
      if (evt.target instanceof Button)
         {
         if ( ((String)what).equals(Resource.GroupsDlg_add) )
            {
            AddGroupDialog d = new AddGroupDialog(this,options);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.GroupsDlg_change) )
            {
            ChangeGroupDialog d = new ChangeGroupDialog(this,options,groupList.getSelectedItem().substring(0,groupList.getSelectedItem().indexOf(" ")));
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.GroupsDlg_remove) )
            {
            RemoveGroupDialog d = new RemoveGroupDialog(this,options,groupList.getSelectedItem().substring(0,groupList.getSelectedItem().indexOf(" ")));
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.GroupsDlg_quit) )
            {
            groupsThread.stop();
            hide();
            dispose();
            return true;
            }
         }
      return false;
      }

   public boolean handleEvent(Event e)
      {
      if( (e.id==Event.WINDOW_DESTROY) && (e.target == this) )
         {
         groupsThread.stop();
         hide();
         dispose();
         return true;
         }
      else if( e.id==Event.LIST_SELECT )
         {
         changeButton.enable();
         removeButton.enable();
         return true;
         }
      else
         return super.handleEvent(e);
      }

   }
