// $Id$
//
// $Log$
//

import java.awt.*;

public class InfoDialog extends Dialog
   {
   protected Button button;
   protected MultiLineLabel label;

   public InfoDialog(Frame parent, String title, String message)
      {
      super(parent, title, true);

      this.setLayout(new BorderLayout(15,15));
      label = new MultiLineLabel(message,20,20);
      this.add("Center",label);
      button = new Button("OK");
      Panel p = new Panel();
      p.setLayout(new FlowLayout(FlowLayout.CENTER,15,15));
      p.add(button);
      this.add("South",p);
      this.pack();
      Rectangle b = parent.bounds();
      reshape( b.x + b.width/2 - size().width/2,
               b.y + b.height/2 - size().height/2,
               size().width,
               size().height );
      }

   public boolean action(Event e, Object arg)
      {
      if (e.target == button)
         {
         this.hide();
         this.dispose();
         return true;
         }
      else return false;
      }

   public boolean handleEvent(Event e)
      {
      if( (e.id==Event.WINDOW_DESTROY) && (e.target == this) )
         {
         hide();
         dispose();
         return true;
         }
      else
         return super.handleEvent(e);
      }

   public boolean gotFocus(Event e, Object arg)
      {
      button.requestFocus();
      return true;
      }

   public static void main(String[] args)
      {
      Frame f = new Frame("InfoDialog Test");
      f.resize(100,100);
      f.show();
      InfoDialog d = new InfoDialog(f, "Title", "TestText\nAuf zwei Zeilen");
      d.show();
      }
   }
