// $Id$
//
// $Log$
//

import java.awt.*;
import java.io.*;

public class MainWin extends Frame implements Log, Options, StatusHandler
   {
   public String reason = "";
   public boolean fromApplet = false;

   PollThread pollThread;

   List logList;

   Button goButton;
   MenuItem goMenu;
   Button pauseButton;
   MenuItem pauseMenu;
   Button flushButton;
   MenuItem flushMenu;
   Button throttleButton;
   MenuItem throttleMenu;
   Button shutdownButton;
   MenuItem shutdownMenu;
   MenuItem abortMenu;
   MenuItem oversyncMenu;
   MenuItem grouplistMenu;
   Button quitButton;

   Button killHostButton;
   Button killUserButton;

   public TextField serverStatus;
   public TextField sysload;
   public TextField news;
   public TextField overview;
   public TextField history;
   public TextField memory;
   public List hostList;
   public List userList;

   MainWin(boolean fromApplet)
      {
      super("Chanco Java");

      this.fromApplet = fromApplet;

      addMenuBar();
      setBackground(Color.lightGray);

      Panel p0 = new Panel();
      p0.setLayout(new GridBagLayout());
      Constrain c = new Constrain(p0);

      c.add( new Label(Resource.MainWin_serverstatus,Label.RIGHT),0,0,1,1,GridBagConstraints.NONE,GridBagConstraints.NORTHEAST,0,0,5,0,0,0);
      serverStatus = new TextField();
      serverStatus.setEditable(false);
      c.add( serverStatus,1,0,9,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,5,0,5,1,0,5);

      c.add( new Label(Resource.MainWin_sysload,Label.RIGHT),0,1,1,1,GridBagConstraints.NONE,GridBagConstraints.NORTHEAST,0,0,5,0,0,0);
      sysload = new TextField(5);
      sysload.setEditable(false);
      c.add( sysload,1,1,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,1,0,0);

      c.add( new Label(Resource.MainWin_news,Label.RIGHT),2,1,1,1,GridBagConstraints.NONE,GridBagConstraints.NORTHEAST,0,0,5,0,0,0);
      news = new TextField(5);
      news.setEditable(false);
      c.add( news,3,1,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,1,0,0);

      c.add( new Label(Resource.MainWin_overview,Label.RIGHT),4,1,1,1,GridBagConstraints.NONE,GridBagConstraints.NORTHEAST,0,0,5,0,0,0);
      overview = new TextField(5);
      overview.setEditable(false);
      c.add( overview,5,1,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,1,0,0);

      c.add( new Label(Resource.MainWin_history,Label.RIGHT),6,1,1,1,GridBagConstraints.NONE,GridBagConstraints.NORTHEAST,0,0,5,0,0,0);
      history = new TextField(5);
      history.setEditable(false);
      c.add( history,7,1,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,1,0,0);

      c.add( new Label(Resource.MainWin_memory,Label.RIGHT),8,1,1,1,GridBagConstraints.NONE,GridBagConstraints.NORTHEAST,0,0,5,0,0,0);
      memory = new TextField(5);
      memory.setEditable(false);
      c.add( memory,9,1,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,1,0,5);


      Panel p2 = new Panel();
      p2.setLayout(new GridBagLayout());
      c = new Constrain(p2);

      c.add( new Label(Resource.MainWin_connected_hosts),0,0,2,1,5,5,0,5);
      c.add( hostList = new List(),0,1,2,1,
             GridBagConstraints.BOTH,GridBagConstraints.NORTHWEST,1,1,0,5,0,0);
      c.add( killHostButton = new Button(Resource.kill), 2,1,1,1,
             GridBagConstraints.VERTICAL,GridBagConstraints.NORTH,0.0,1.0,0,5,5,5);

      c.add( new Label(Resource.MainWin_connected_users),0,2,2,1,5,5,0,5);
      c.add( userList = new List(),0,3,2,1,
             GridBagConstraints.BOTH,GridBagConstraints.NORTHWEST,1,1,0,5,0,0);
      c.add( killUserButton = new Button(Resource.kill), 2,3,1,1,
             GridBagConstraints.VERTICAL,GridBagConstraints.NORTH,0.0,1.0,0,5,5,5);


      Panel p1 = new Panel();
      p1.setLayout( new FlowLayout(FlowLayout.LEFT,10,10) );
      p1.add( goButton       = new Button(Resource.go) );
      p1.add( flushButton    = new Button(Resource.flush) );
      p1.add( pauseButton    = new Button(Resource.pause) );
      p1.add( throttleButton = new Button(Resource.throttle) );
      p1.add( shutdownButton = new Button(Resource.shutdown) );
      p1.add( quitButton     = new Button(Resource.quit) );

      add( "North", p0);
      add( "Center", p2);
      add( "South", p1);

      if (!fromApplet)
         readIniFile();

      setState(MainWin.SERVER_NOT_CONNECTED);
      pollThread = new PollThread(this); pollThread.start();
      }

   private void addMenuBar()
      {
      Menu server = new Menu(Resource.server);
      server.add(grouplistMenu = new MenuItem(Resource.grouplist));
      server.add(oversyncMenu = new MenuItem(Resource.oversync));
      server.addSeparator();
      server.add(goMenu = new MenuItem(Resource.go));
      server.add(flushMenu = new MenuItem(Resource.flush));
      server.add(pauseMenu = new MenuItem(Resource.pause));
      server.add(throttleMenu = new MenuItem(Resource.throttle));
      server.addSeparator();
      server.add(shutdownMenu = new MenuItem(Resource.shutdown));
      server.add(abortMenu = new MenuItem(Resource.abort));

      Menu chanco = new Menu(Resource.chanco);
      if (!fromApplet) // im Browser kein Zugriff auf lokale Files
         {
         chanco.add(new MenuItem(Resource.options));
         chanco.addSeparator();
         }
      chanco.add(new MenuItem(Resource.quit));

      MenuBar mb = new MenuBar();
      mb.add(chanco);
      mb.add(server);
      setMenuBar(mb);
      }

   public boolean handleEvent(Event e)
      {
      if( (e.id==Event.WINDOW_DESTROY) && (e.target == this) )
         {
         quit();
         return true;
         }
      else
         return super.handleEvent(e);
      }

   public boolean action( Event evt, Object what )
      {
      if (evt.target instanceof Button || evt.target instanceof MenuItem)
         {
         if ( ((String)what).equals(Resource.grouplist) )
            {
            GroupsDialog d = new GroupsDialog(this,this);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.go) )
            {
            String[] reasonValue = {reason};
            GoDialog d = new GoDialog(this,this,this,reasonValue);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.flush) )
            {
            String[] reasonValue = {reason};
            FlushDialog d = new FlushDialog(this,this,this,reasonValue);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.pause) )
            {
            String[] reasonValue = {reason};
            PauseDialog d = new PauseDialog(this,this,this,reasonValue);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.throttle) )
            {
            String[] reasonValue = {reason};
            ThrottleDialog d = new ThrottleDialog(this,this,this,reasonValue);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.shutdown) )
            {
            ShutdownDialog d = new ShutdownDialog(this,this,this);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.abort) )
            {
            AbortDialog d = new AbortDialog(this);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.oversync) )
            {
            OversyncDialog d = new OversyncDialog(this,this);
            d.show();
            return true;
            }
         if ( evt.target == killHostButton )
            {
            if (hostList.getSelectedItem() != null)
               {
               String[] dummy = {};
               KillHostDialog d = new KillHostDialog(this,this,dummy,hostList.getSelectedItem());
               d.show();
               }
            return true;
            }
         if ( evt.target == killUserButton )
            {
            if (hostList.getSelectedItem() != null)
               {
               String[] dummy = {};
               KillUserDialog d = new KillUserDialog(this,this,dummy,hostList.getSelectedItem());
               d.show();
               }
            return true;
            }
         if ( ((String)what).equals(Resource.options) )
            {
            OptionsDialog d = new OptionsDialog(this, this);
            d.show();
            return true;
            }
         if ( ((String)what).equals(Resource.quit) )
            {
            quit();
            return true;
            }
         }
      return false;
      }

   protected void finalize()
      {
      if (pollThread != null) pollThread.stop();
      }

   protected void quit()
      {
      QuitDialog d = new QuitDialog(this);
      d.show();
      }

// ***************************************************************************
//    Operationen fuer Interface StatusHandler
// ***************************************************************************

   public void setState(int state)
      {
      switch (state)
         {
         case SERVER_RUNNING:
            serverStatus.setText(Resource.ServerStatus_running);
            goButton.disable();
            goMenu.disable();
            flushButton.enable();
            flushMenu.enable();
            pauseButton.enable();
            pauseMenu.enable();
            throttleButton.enable();
            throttleMenu.enable();
            shutdownButton.enable();
            shutdownMenu.enable();
            abortMenu.enable();
            oversyncMenu.enable();
            grouplistMenu.enable();
            break;

         case SERVER_FLUSHED:
            serverStatus.setText(Resource.ServerStatus_flushed+"; "+reason);
            goButton.enable();
            goMenu.enable();
            flushButton.disable();
            flushMenu.disable();
            pauseButton.enable();
            pauseMenu.enable();
            throttleButton.enable();
            throttleMenu.enable();
            shutdownButton.enable();
            shutdownMenu.enable();
            abortMenu.enable();
            oversyncMenu.enable();
            grouplistMenu.disable();
            break;

         case SERVER_PAUSED:
            serverStatus.setText(Resource.ServerStatus_paused+": "+reason);
            goButton.enable();
            goMenu.enable();
            flushButton.disable();
            flushMenu.disable();
            pauseButton.disable();
            pauseMenu.disable();
            throttleButton.enable();
            throttleMenu.enable();
            shutdownButton.enable();
            shutdownMenu.enable();
            abortMenu.enable();
            oversyncMenu.enable();
            grouplistMenu.disable();
            break;

         case SERVER_THROTTLED:
            serverStatus.setText(Resource.ServerStatus_throttled+": "+reason);
            goButton.enable();
            goMenu.enable();
            flushButton.disable();
            flushMenu.disable();
            pauseButton.disable();
            pauseMenu.disable();
            throttleButton.disable();
            throttleMenu.disable();
            shutdownButton.enable();
            shutdownMenu.enable();
            abortMenu.enable();
            oversyncMenu.enable();
            grouplistMenu.disable();
            break;

         case SERVER_NOT_CONNECTED:
            serverStatus.setText(Resource.ServerStatus_not_connected);
            goButton.disable();
            goMenu.disable();
            flushButton.disable();
            flushMenu.disable();
            pauseButton.disable();
            pauseMenu.disable();
            throttleButton.disable();
            throttleMenu.disable();
            shutdownButton.disable();
            shutdownMenu.disable();
            abortMenu.disable();
            oversyncMenu.disable();
            grouplistMenu.disable();
         default:
         }
      }

// ***************************************************************************
//    Operationen fuer Interface Log
// ***************************************************************************

      public void addToLog(String s)
         { logList.addItem(s); }

// ***************************************************************************
//    Operationen fuer Interface Options
// ***************************************************************************

   int changiPort;
   int changiSleep;
   String changiHost;
   String changiUser;

   public void readIniFile()
      {
      if (!fromApplet) // im Browser kein Zugriff auf lokale Files
         {
         File iniFile = new File(JavaChanco.iniFileName);
         long size = iniFile.length();
         long bytes_read = 0;

         if (!iniFile.exists())
            {
            DataOutputStream out = null;
            try
               {
               out = new DataOutputStream(new FileOutputStream(iniFile));
               out.writeBytes(Resource.Config_user+"=user\n");
               out.writeBytes(Resource.Config_host+"=localhost\n");
               out.writeBytes(Resource.Config_port+"=119\n");
               out.writeBytes(Resource.Config_sleep+"=10\n");
               }
            catch (IOException e) {System.err.println("Error writing default .ini-file");}
            finally { if (out!=null) try {out.close();} catch (IOException e) {} }
            }

         DataInputStream in = null;
         try
            {
            in = new DataInputStream(new FileInputStream(iniFile));
            for (;;)
               {
               String line = in.readLine();
               if (line == null) break;

               String keyword = line.substring(0,line.indexOf("="));
               if (keyword.equalsIgnoreCase(Resource.Config_user))
                  setUser(line.substring(line.indexOf("=")+1));
               else if (keyword.equalsIgnoreCase(Resource.Config_host))
                  setHost(line.substring(line.indexOf("=")+1));
               else if (keyword.equalsIgnoreCase(Resource.Config_port))
                  setPort(Integer.parseInt(line.substring(line.indexOf("=")+1)));
               else if (keyword.equalsIgnoreCase(Resource.Config_sleep))
                  setSleep(Integer.parseInt(line.substring(line.indexOf("=")+1)));
               }
            }
         catch (IOException e) {}
         finally { if (in!=null) try {in.close();} catch (IOException e) {} }
         }
      }

   public void writeIniFile()
      {
      if (!fromApplet) // im Browser kein Zugriff auf lokale Files
         {
         File iniFile = new File(JavaChanco.iniFileName);
         DataOutputStream out = null;
         try
            {
            out = new DataOutputStream(new FileOutputStream(iniFile));
            out.writeBytes(Resource.Config_user+"="+getUser()+"\n");
            out.writeBytes(Resource.Config_host+"="+getHost()+"\n");
            out.writeBytes(Resource.Config_port+"="+Integer.toString(getPort())+"\n");
            out.writeBytes(Resource.Config_sleep+"="+Integer.toString(getSleep())+"\n");
            }
         catch (IOException e) {System.err.println("Error writing default .ini-file");}
         finally { if (out!=null) try {out.close();} catch (IOException e) {} }
         }
      }

   public void setUser(String user)
      {
      changiUser = user;
      }
   public String getUser() { return changiUser; }

   public void setHost(String host) { changiHost = host; }
   public String getHost() { return changiHost; }

   public void setPort(int port) { changiPort = port; }
   public int getPort() { return changiPort; }

   public void setSleep(int sleep) { changiSleep = sleep; }
   public int getSleep() { return changiSleep; }
   }
