// $Id$
//
// $Log$
//

import java.awt.*;

public class OversyncDialog extends Dialog
   {
   Options options;
   Checkbox stop, slow, normal, fast;

   public OversyncDialog(Frame parent, Options options)
      {
      super(parent, Resource.OversyncDialog_title, false);
      this.options = options;

      Panel p0 = new Panel();
      p0.setLayout(new GridBagLayout());
      Constrain c = new Constrain(p0);

      c.add( new MultiLineLabel(Resource.OversyncDialog_message,20,20),0,0,1,1,GridBagConstraints.BOTH,GridBagConstraints.NORTH,1.0,1.0,5,5,0,5);

      CheckboxGroup cbg = new CheckboxGroup();
      stop = new Checkbox(Resource.OversyncDialog_stop, cbg, false);
      c.add(stop,0,1,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,0,20,0,5);
      slow = new Checkbox(Resource.OversyncDialog_slow, cbg, false);
      c.add(slow,0,2,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,0,20,0,5);
      normal = new Checkbox(Resource.OversyncDialog_normal, cbg, true);
      c.add(normal,0,3,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,0,20,0,5);
      fast = new Checkbox(Resource.OversyncDialog_fast, cbg, false);
      c.add(fast,0,4,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,0,20,5,5);

      Panel p = new Panel();
      p.setLayout(new FlowLayout(FlowLayout.CENTER,15,5));
      p.add(new Button(Resource.ok));
      p.add(new Button(Resource.cancel));

      setLayout(new BorderLayout(15,15));
      add("North",p0);
      add("South",p);
      pack();
      Rectangle b = parent.bounds();
      reshape( b.x + b.width/2 - 150,
               b.y + b.height/2 - size().height/2,
               size().width,
               size().height );
      }

   public boolean action(Event e, Object arg)
      {
      if (e.target instanceof Button)
         {
         if (((String)arg).equals(Resource.ok))
            {
            String[] s = {options.getUser(),"Y","normal"};
            if (slow.getState())
               s[2] = "slow";
            else if (fast.getState())
               s[2] = "fast";
            else if (stop.getState())
               s[2] = "stop";
            String ret = UDPSocket.transact(s, options.getHost(), options.getPort());
            if (!ret.startsWith("0"))
               {
               InfoDialog d = new InfoDialog((Frame)getParent(),
                                             Resource.OversyncDlg_failed_title,
                                             Resource.OversyncDlg_failed_message);
               d.show();
               }
            }
         this.hide();
         this.dispose();
         return true;
         }
      else return false;
      }

   public boolean handleEvent(Event e)
      {
      if( (e.id==Event.WINDOW_DESTROY) && (e.target == this) )
         {
         hide();
         dispose();
         return true;
         }
      else
         return super.handleEvent(e);
      }

   }
