/*
 * This part was written by Harald Kipp
 *
 * Bug reports to
 *
 *  harald@os2point.ping.de
 *
 */

const char chanpath_rcsid[] = "$Id: chanpath.c,v 1.1 1997/02/13 11:09:15 oliver Exp $";

#include <stdlib.h>
#include <string.h>

#include <chanpath.h>

/************************************************************************/
/*                                                                      */
/************************************************************************/
static char *bsl_path(char *name, char *path)
{
    char *cp = name;

    while(*path) {
        if(*path == '/')
            *cp++ = '\\';
        else
            *cp++ = *path;
        path++;
    }
    *cp = '\0';
    return(cp);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
char *changi_path(char *path, char *name, char *envi)
{
    char *env;
    char *cp;

    /*
     * If the specific environment has been set, accept it.
     * Do not make any changes to allow full user control.
     */
    if(envi && (env = getenv(envi)) != NULL) {
        strcpy(path, envi);
        return(path);
    }

    /*
     * Get the home path. If CHANGIWORKDIR isn't defined,
     * use the current directory.
     */
    if((env = getenv("CHANGIWORKDIR")) != NULL)
        strcpy(path, env);
    else
        getcwd(path, _MAX_PATH);
    cp = path + strlen(path);
    *cp++ = '\\';
    strcpy(cp, name);

    return(path);
}

/*
 * $Log: chanpath.c,v $
 * Revision 1.1  1997/02/13 11:09:15  oliver
 * initial revision
 *
 */
