/*----------------------------------------------------------------------*/
/* Copyright (c) 1996-97 by Harald Kipp. All rights reserved.           */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/* Parts are copyright by Kendra Electronic Wonderworks.                */
/*                                                                      */
/* Send bug reports to                                                  */
/*                                                                      */
/*      harald@os2point.ping.de                                         */
/*                                                                      */
/*----------------------------------------------------------------------*/

const char jobid_rcsid[] = "$Id: jobid.c,v 1.1 1997/02/13 11:09:19 oliver Exp $";

#include <stdlib.h>
#include <stdio.h>
#include <process.h>

#include <xfile.h>
#include <jobid.h>

/************************************************************************/
/*                                                                      */
/*                                                                      */
/************************************************************************/
char *job_id(char *seqf, int update)
{
    static char job[4];
    static char set[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    static long base = sizeof(set) - 1;
    long seq;
    size_t c = sizeof(job) - 1;
    FILE *fp = xfopen(seqf, "r");

    /*
     * Read last sequence number
     */
    if(fp) {
        if(fscanf(fp, "%ld", &seq) != 1)
            seq = getpid();
        fclose(fp);
    }
    else {
        perror(seqf);
        seq = getpid();
    }

    if(update || fp == NULL) {
        /*
         * Update next sequence number
         */
        fp = xfopen(seqf, "w");
        if(fp) {
            fprintf(fp, "%ld\n", seq + 1);
            fclose(fp);
        }
        else
            perror(seqf);
    }

    /*
     * Convert sequence to 3-char job id
     */
    seq %= base * base * base;
    job[c] = '\0';
    while(c-- > 0) {
        job[c] = set[seq % base];
        seq /= base;
    }
    return(job);
}

/*
 * $Log: jobid.c,v $
 * Revision 1.1  1997/02/13 11:09:19  oliver
 * initial revision
 *
 */
