/*
 * This part was written by Harald Kipp
 *
 * Bug reports to
 *
 *  harald@os2point.ping.de
 *
 */

const char ntdir_rcsid[] = "$Id: ntdir.c,v 1.1 1997/02/13 11:09:27 oliver Exp $";

#include <windows.h>
#include <stdlib.h>
#include <string.h>

#include <scangrpd.h>

#define FBUFSIZE    12272
#define AINCSIZE    252

/************************************************************************/
/*                                                                      */
/************************************************************************/
static int longcmp(const void *x, const void *y)
{
    if(*(long *)x > *(long *)y)
        return(1);
    else if(*(long *)x < *(long *)y)
        return(-1);
    return(0);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
int scan_groupdir(const char *group, const char *newsdir, long **art_array, int *siz_array)
{
    long artnum;
    HANDLE hdir;
    WIN32_FIND_DATA ffb;
    BOOL foundnext = TRUE;
    char *cp;
    int num_arts = 0;
    int  l = strlen(newsdir);
    char *tmplt = malloc(l + strlen(group) + 5);

    cp = strcpy(tmplt, newsdir) + l;
    *cp++ = '\\';
    for(cp = strcpy(cp, group); *cp; cp++)
        if(*cp == '.')
            *cp = '\\';
    *cp++ = '\\';
    *cp++ = '*';
    *cp++ = '.';
    *cp = '\0';

    if( (hdir = FindFirstFile(tmplt, &ffb)) != INVALID_HANDLE_VALUE ) {
        while (foundnext) {
            if((artnum = atol(ffb.cFileName)) != 0) {
                if(num_arts >= *siz_array) {
                    *siz_array += AINCSIZE;
                    *art_array = realloc(*art_array, *siz_array * sizeof(long));
                }
                (*art_array)[num_arts++] = artnum;
            }
            foundnext = FindNextFile(hdir, &ffb);
        }
        FindClose(hdir);
        if(num_arts)
            qsort(*art_array, num_arts, sizeof(long), longcmp);

    }
    free(tmplt);

    return(num_arts);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
int grab_quefile(const char *dirname, const char *newname)
{
    return(-1);
}

/*
 * $Log: ntdir.c,v $
 * Revision 1.1  1997/02/13 11:09:27  oliver
 * initial revision
 *
 */
