const char ntmutex_rcsid[] = "$Id: ntmutex.c,v 1.1 1997/02/13 11:09:27 oliver Exp $";

#include <windows.h>
#include <stdio.h>

#include <syslog.h>

#include <mutex.h>

/************************************************************************/
/*                                                                      */
/************************************************************************/
long create_mutex(void)
{
    unsigned long mux;

    if (( mux = (long)CreateMutex(0, FALSE, 0)) == 0) {
        syslog(LOG_ERR, "Error %u (DosCreateMutexSem)\n", GetLastError());
        return(-1);
    }
    return((long)mux);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
void destroy_mutex(long mux)
{
    CloseHandle( (HANDLE)mux );
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
int request_mutex(long *muxp, long maxwait)
{
   if ( WaitForSingleObject( (HANDLE)(*muxp), maxwait )  == 0xFFFFFFFF ) {
      syslog(LOG_ERR, "Error %u (WaitForSingleObject %lu)\n", GetLastError(), maxwait);
      return(-1);
   }

   return(0);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
void release_mutex(long mux)
{
    ReleaseMutex((HANDLE)mux);
}

/*
 * $Log: ntmutex.c,v $
 * Revision 1.1  1997/02/13 11:09:27  oliver
 * initial revision
 *
 */
