/*
 * ntpipe.c
 *
 * The IBM CSet++ doesn't have pipe() and popen(), pclose() calls.
 * This module fixes this lack of important functions.
 *
 * Windows NT version
 *
 * Bug reports related to THIS modified version should be sent to
 *
 *  harald@os2point.ping.de
 *
 */

const char ntpipe_rcsid[] = "$Id: ntpipe.c,v 1.1 1997/02/13 11:09:28 oliver Exp $";

#include <windows.h>
#include <stdio.h>
#include <process.h>

#include <pipe.h>

#ifndef _threadid
static int mythreadid = 0;
#define _threadid (&mythreadid)
#endif
int chldId[256];

#if 0

/************************************************************************/
/*                                                                      */
/* Can't get this working. For the time being we use a cheap hack. See  */
/* below.                                                               */
/*                                                                      */
/************************************************************************/
FILE *popen(char *cmd, char *mode)
   {
   HANDLE hChildStdoutRd, hChildStdoutWr,
          hChildStdinRd,  hChildStdinWr,  hChildStdinWrDup,
          hSaveStdin, hSaveStdout;
   SECURITY_ATTRIBUTES saAttr;
   char *comspec;
   FILE * pip;

   saAttr.nLength = sizeof(SECURITY_ATTRIBUTES);
   saAttr.bInheritHandle = TRUE;
   saAttr.lpSecurityDescriptor = NULL;

   if (mode[0] == 'r')
      {
      /* Create a pipe for child's stdout */
      if (! CreatePipe(&hChildStdoutRd, &hChildStdoutWr, &saAttr, 0))
         perror("stdout pipe creation failed");

      /* Save Handle to current stdout */
      hSaveStdout = GetStdHandle(STD_OUTPUT_HANDLE);

      /* Set the writehandle of the pipe to be stdout */
      if (! SetStdHandle(STD_OUTPUT_HANDLE, hChildStdoutWr))
         perror("redirecting stdout failed");

//      if (! DuplicateHandle( GetCurrentProcess(), hChildStdoutRd, GetCurrentProcess(), &hChildStdoutRdDup, 0, FALSE, DUPLICATE_SAME_ACCESS ))
//         perror("DuplicateHandle failed");

      if((comspec = getenv("CHANGICOMSPEC")) == NULL &&
         (comspec = getenv("COMSPEC")) == NULL)
         comspec = "C:\\winnt\\system32\\CMD.EXE";

      if ( (chldId[*_threadid] = _spawnlp(P_NOWAIT, comspec, comspec, "/c", cmd, NULL)) == 0 )
         perror("spawn failed");

      if (! SetStdHandle(STD_OUTPUT_HANDLE, hSaveStdout))
         perror("restoring stdout failed");
      if (! CloseHandle(hChildStdoutWr))
         perror("Close hChildStdoutWr failed");
      return fdopen((int)hChildStdoutRd, mode);
      }

   else

      {
      if (! CreatePipe(&hChildStdinRd, &hChildStdinWr, &saAttr, 0))
         perror("stdout pipe creation failed");

      hSaveStdin = GetStdHandle(STD_INPUT_HANDLE);

      if (! SetStdHandle(STD_INPUT_HANDLE, hChildStdinRd))
      perror("redirecting stdin failed");

      if (! DuplicateHandle( GetCurrentProcess(), hChildStdinWr, GetCurrentProcess(), &hChildStdinWrDup, 0, FALSE, DUPLICATE_SAME_ACCESS ))
         perror("DuplicateHandle failed");
      CloseHandle(hChildStdinWr);

      if((comspec = getenv("CHANGICOMSPEC")) == NULL &&
         (comspec = getenv("COMSPEC")) == NULL)
         comspec = "C:\\winnt\\system32\\CMD.EXE";

      if ( (chldId[*_threadid] = _spawnlp(P_NOWAIT, comspec, comspec, "/c", cmd, NULL)) == 0 )
         perror("spawn failed");

      if (! SetStdHandle(STD_INPUT_HANDLE, hSaveStdin))
         perror("restoring stdin failed");
      fprintf(stderr, "Pipe::fdopen\n");
      if ((pip = fdopen((int)hChildStdinWrDup, mode)) == 0)
         perror("Pipe::fdopen failed");
      return pip;
      }
   }

int pclose(FILE * pip)
{
    int i;

    if(fclose(pip))
       perror("error closing pipe");

    if(cwait(&i, chldId[*_threadid], WAIT_GRANDCHILD) == -1)
      perror("child process");
    return i;
}
#endif

/************************************************************************/
/*                                                                      */
/* THE HACK                                                             */
/*                                                                      */
/************************************************************************/
typedef struct {
    FILE *fp;
    char *tname;
    char *cmd;
    char *mode;
} PIPECMD;

FILE *popen(char *cmd, char *mode)
{
    char cmdline[128];
    char *tname = tempnam(cfg.workdir, "PIP");

    if(mode[0] == 'r') {
        sprintf(cmdline, "%s > %s", cmd, tname);
        if(system(cmdline)) {
            free(tname);
            return(NULL);
        }
    }
    else {
    }

    free(tname);
}

int pclose(FILE * pip)
{
}

/*
 * $Log: ntpipe.c,v $
 * Revision 1.1  1997/02/13 11:09:28  oliver
 * initial revision
 *
 */
