/*
 * This part was written by Harald Kipp
 *
 * Bug reports to
 *
 *  harald@os2point.ping.de
 *
 */

const char os2dir_rcsid[] = "$Id: os2dir.c,v 1.1 1997/02/13 11:09:29 oliver Exp $";

#define INCL_DOSFILEMGR
#include <os2.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <scangrpd.h>

#define FBUFSIZE    12272
#define AINCSIZE    252

/************************************************************************/
/*                                                                      */
/************************************************************************/
static int longcmp(const void *x, const void *y)
{
    if(*(long *)x > *(long *)y)
        return(1);
    else if(*(long *)x < *(long *)y)
        return(-1);
    return(0);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
int scan_groupdir(const char *group, const char *newsdir, long **art_array, int *siz_array)
{
    long artnum;
    HDIR hdir;
    PFILEFINDBUF3 pffb;
    unsigned long cffb;
    APIRET rc;
    int i;
    char *cp;
    int num_arts = 0;
    PFILEFINDBUF3 paffb = malloc(FBUFSIZE);
    int  l = strlen(newsdir);
    char *tmplt = malloc(l + strlen(group) + 5);

    cp = strcpy(tmplt, newsdir) + l;
    *cp++ = '\\';
    for(cp = strcpy(cp, group); *cp; cp++)
        if(*cp == '.')
            *cp = '\\';
    *cp++ = '\\';
    *cp++ = '*';
    *cp++ = '.';
    *cp = '\0';

    cffb = 252;
    hdir = (HDIR)HDIR_CREATE;
    if((rc = DosFindFirst(tmplt, &hdir, 0, paffb, FBUFSIZE, &cffb, 1)) == 0) {
        while (!rc && cffb) {
            pffb = paffb;
            for(i = 0; i < cffb; i++) {
                if((artnum = atol(pffb->achName)) != 0) {
                    if(num_arts >= *siz_array) {
                        *siz_array += AINCSIZE;
                        *art_array = realloc(*art_array, *siz_array * sizeof(long));
                    }
                    (*art_array)[num_arts++] = artnum;
                }
                pffb = (PFILEFINDBUF3)(((char *)pffb) + pffb->oNextEntryOffset);
            }
            cffb = 252;
            rc = DosFindNext(hdir, paffb, FBUFSIZE, &cffb);
        }
        DosFindClose(hdir);
        if(num_arts)
            qsort(*art_array, num_arts, sizeof(long), longcmp);

    }
    free(paffb);
    free(tmplt);

    return(num_arts);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
int grab_quefile(const char *dirname, const char *newname)
{
    int result = -1;
    HDIR hdir;
    PFILEFINDBUF3 pffb;
    unsigned long cffb;
    APIRET rc;
    int i;
    PFILEFINDBUF3 paffb = malloc(FBUFSIZE);
    char *tmplt = malloc(_MAX_PATH);
    char *oldname = malloc(_MAX_PATH);
    char *basename;

    strcpy(oldname, dirname);
    basename = oldname + strlen(oldname);
    *basename++ = '\\';

    strcpy(tmplt, dirname);
    strcat(tmplt, "\\*");
    cffb = 252;
    hdir = (HDIR)HDIR_CREATE;
    if((rc = DosFindFirst(tmplt, &hdir, 0, paffb, FBUFSIZE, &cffb, 1)) == 0) {
        while (!rc && cffb) {
            pffb = paffb;
            for(i = 0; i < cffb; i++) {
                if(pffb->achName[0] != '.') {
                    strcpy(basename, pffb->achName);
                    if((result = rename(oldname, newname)) == 0)
                        break;
                }
                pffb = (PFILEFINDBUF3)(((char *)pffb) + pffb->oNextEntryOffset);
            }
            cffb = 252;
            rc = DosFindNext(hdir, paffb, FBUFSIZE, &cffb);
        }
        DosFindClose(hdir);
    }
    free(paffb);
    free(tmplt);
    free(oldname);

    return(result);
}

/*
 * $Log: os2dir.c,v $
 * Revision 1.1  1997/02/13 11:09:29  oliver
 * initial revision
 *
 */
