/*----------------------------------------------------------------------*/
/* Copyright (c) 1996-97 by Harald Kipp. All rights reserved.           */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/* Parts are copyright by Kendra Electronic Wonderworks.                */
/*                                                                      */
/* Send bug reports to                                                  */
/*                                                                      */
/*      harald@os2point.ping.de                                         */
/*                                                                      */
/*----------------------------------------------------------------------*/

const char radixpck_rcsid[] = "$Id: radixpck.c,v 1.1 1997/02/13 11:09:34 oliver Exp $";

#include <stdlib.h>
#include <string.h>
#include <radixpck.h>

char radixtbl[] ="0123456789BCDFGHJKLMNPQRSTVWXYZbcdfghjklmnpqrstvwxyz";

#define RADIX (sizeof(radixtbl)-1)

/************************************************************************/
/* radixpack                                                            */
/*                                                                      */
/* Packs a long value using alphanumeric characters.                    */
/*                                                                      */
/************************************************************************/
char *radixpack(unsigned long val, char *pck)
{
    char buf[8];
    char *cp = &buf[sizeof(buf) - 1];

    *cp = '\0';
    do {
        *--cp = radixtbl[val % RADIX];
        val /= RADIX;
    } while(val);

    return(strcpy(pck, cp));
}

/************************************************************************/
/* radixunpack                                                          */
/*                                                                      */
/* Unpacks a long value from a string created by radixpack.             */
/*                                                                      */
/************************************************************************/
unsigned long radixunpack(char *pck)
{
    char *cp;
    unsigned long val = 0;

    while(*pck) {
        val *= RADIX;
        for(cp = radixtbl; *cp; cp++) {
            if(*cp == *pck)
                break;
            val++;
        }
        pck++;
    }

    return(val);
}

/*
 * $Log: radixpck.c,v $
 * Revision 1.1  1997/02/13 11:09:34  oliver
 * initial revision
 *
 */
