/*
 * This OS/2 part was done by Harald Kipp, stealing code from
 *
 *      INN written by Rich $alz
 *
 * Bug reports should be sent to
 *
 *  harald@os2point.ping.de
 *
 */

const char sendcmd_rcsid[] = "$Id: sendcmd.c,v 1.1 1997/02/13 11:09:36 oliver Exp $";

#include <types.h>
#include <sys\socket.h>
#include <netdb.h>

#undef min
#include <stdlib.h>
#include <ctype.h>

#include <syslog.h>
#include <chlimits.h>

/************************************************************************/
/*                                                                      */
/************************************************************************/
int send_cmd(char *line, char *controlport, long mswait)
{
    struct sockaddr_in server;
    struct sockaddr_in from;
    int fromlen;
    int sock;
    int n;
    unsigned short port;
    struct servent *sp;

    if((sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        syslog(LOG_ERR, "socket failed");
        return(-1);
    }

    /*
     * Determine the port to be used.
     */
    if(isdigit(*controlport))
        port = (unsigned short)atoi(controlport);
    else if ((sp = getservbyname(controlport, "udp")) != NULL)
        port = (unsigned short)ntohs((unsigned short)(sp->s_port));
    else {
        port = 119;
        syslog(LOG_INFO, "Unknown service: %s/udp, using port %u\n", controlport, port);
    }

    server.sin_family = AF_INET;
    server.sin_port = htons(port);
    server.sin_addr.s_addr = inet_addr("127.0.0.1");
    if(sendto(sock, line, strlen(line), 0, (struct sockaddr * )&server, sizeof(server)) < 0) {
        syslog(LOG_ERR, "sendto failed");
        return(-1);
    }
    if(mswait == -1) {
        strcpy(line, "0 OK");
        return(0);
    }

    fromlen = sizeof(from);
    if(select(&sock, 1, 0, 0, mswait) <= 0) {
        syslog(LOG_ERR, "Control port timed out");
        return(-1);
    }
    if((n = recvfrom(sock, line, 64, 0, (struct sockaddr * )&from, &fromlen)) > 0) {
        line[n] = '\0';
        return(0);
    }
    syslog(LOG_ERR, "recvfrom failed");
    return(-1);
}

/*
 * $Log: sendcmd.c,v $
 * Revision 1.1  1997/02/13 11:09:36  oliver
 * initial revision
 *
 */
