const char addhostwindow_rcsid[] =
"$Id: addhostwindow.cpp,v 1.5 1997/04/05 16:56:57 oliver Exp $";

#include <itrace.hpp>
#include <ifont.hpp>

#include "addhostwindow.hpp"
#include "hostcnr.hpp"
#include "changi_l.hpp"
#include "changi_l.h"

AddHostWindow::AddHostWindow(HostCnr* target)
   : GetStringWindow(
      ChangiLWindow::getMainWindow(),
      IApplication::current().userResourceLibrary().loadString(STR_ADDHOST_TITLE),
      IApplication::current().userResourceLibrary().loadString(STR_ADDHOST_MESSAGE))
   , target_(target)
   {
   IFUNCTRACE_DEVELOP();
#ifdef __WINDOWS__
   setFont(IFont("Helv",8));
#endif
   }

AddHostWindow::~AddHostWindow()
   {
   IFUNCTRACE_DEVELOP();
   }

void AddHostWindow::doIt(const IString& string)
   {
   IFUNCTRACE_DEVELOP();
   target_->addHost(string);
   }

/*
 * $Log: addhostwindow.cpp,v $
 * Revision 1.5  1997/04/05 16:56:57  oliver
 * various bugfixes
 *
 * Revision 1.4  1997/03/18 16:12:38  oliver
 * bugfixes
 * menu changet to resource
 * help added
 * profile for Window-position added
 *
 * Revision 1.3  1997/02/14 12:17:07  oliver
 * added new generic OkCancelDialog
 * addHost now refuses to add a host with name
 *
 * Revision 1.2  1997/02/13 19:19:25  oliver
 * allGroupsContainer now recognizes subsription status
 *
 * Revision 1.1  1997/02/13 13:58:52  oliver
 * initial revision
 *
 */
