#ifndef CHANGI_L_H
#define CHANGI_L_H

/*
 * $Id: changi_l.h,v 1.14 1997/04/05 16:56:59 oliver Exp $
 */

//**************************************************************************
// window ids - used by IWindow constructors (eg IStaticText, AHelloWindow)*
//**************************************************************************
#define WND_MAIN         0x1000
#define WND_ALLGROUPSCONT (WND_MAIN + 0x0001)
#define WND_SUBGROUPSCONT (WND_MAIN + 0x0002)
#define WND_NEWGROUPSCONT (WND_MAIN + 0x0003)
#define WND_INFO         (WND_MAIN + 0x0004)
#define WND_GROUPNOTEBK  (WND_MAIN + 0x0005)
#define WND_HOSTCONT     (WND_MAIN + 0x0006)

#define WND_CLIENTAREA   (0x8008)

//**************************************************************************
// HelpTable
//**************************************************************************
#define ID_HELP_TABLE    (WND_MAIN + 0x00FD)
#define ID_MAIN_SUBTABLE (WND_MAIN + 0x00FF)

//**************************************************************************
// String IDs - used to relate resources to IStaticText and ITitle         *
//**************************************************************************
#define STR_RES             (0x1100)
#define STR_NBK_ALL         (STR_RES + 0x0000)
#define STR_NBK_SUB         (STR_RES + 0x0001)
#define STR_NBK_NEW         (STR_RES + 0x0002)
#define STR_ADDHOST_TITLE   (STR_RES + 0x0003)
#define STR_ADDHOST_MESSAGE (STR_RES + 0x0004)
#define STR_REMHOST_MESSAGE (STR_RES + 0x0005)
#define STR_SUB_OR_UNSUB    (STR_RES + 0x0006)
#define STR_CHILDREN_TOO    (STR_RES + 0x0007)
#define STR_SAVE_CONFIG     (STR_RES + 0x0008)
#define STR_NEWSGROUPS      (STR_RES + 0x0009)
#define STR_DESCRIPTION     (STR_RES + 0x000a)
#define STR_LOADGROUPS      (STR_RES + 0x000b)

#define ERR_SUCK_LIST       (STR_RES   + 0x0050)
#define ERR_ALREADY_SUBSCR1 (ERR_SUCK_LIST + 0x0001)
#define ERR_ALREADY_SUBSCR2 (ERR_SUCK_LIST + 0x0002)
#define ERR_SUCK_RUNNING    (ERR_SUCK_LIST + 0x0003)
#define ERR_SUCK_ARTS       (ERR_SUCK_LIST + 0x0004)
#define ERR_HOST_EXISTS     (ERR_SUCK_LIST + 0x0005)

//**************************************************************************
// Menu IDs - used to relate command ID to menu items, buttons, and keys   *
//**************************************************************************
#define MI_FILE          0x1200
#define MI_EXIT          (MI_FILE + 0x0001)

#define MI_HOST          (MI_FILE + 0x0010)
#define MI_HOST_POPUP    (MI_FILE + 0x0011)
#define MI_ADDHOST       (MI_FILE + 0x0012)
#define MI_REMHOST       (MI_FILE + 0x0013)
#define MI_SUCKLIST      (MI_FILE + 0x0014)
#define MI_SUCKARTS      (MI_FILE + 0x0015)
#define MI_HOSTCNR_POPUP (MI_FILE + 0x0016)
#define MI_REMHOST_POP   (MI_FILE + 0x0017)
#define MI_SUCKLIST_POP  (MI_FILE + 0x0018)
#define MI_SUCKARTS_POP  (MI_FILE + 0x0019)

#define MI_GROUP         (MI_FILE + 0x0020)
#define MI_GROUP_POPUP   (MI_FILE + 0x0021)
#define MI_ADDGROUP      (MI_FILE + 0x0023)
#define MI_REMGROUP      (MI_FILE + 0x0024)
#define MI_CHANGEGROUP   (MI_FILE + 0x0025)

#define MI_MAIN_HELP         (MI_FILE + 0x00f0)
#define MI_MAIN_HELP_INDEX   (MI_FILE + 0x00f1)
#define MI_MAIN_HELP_GENERAL (MI_FILE + 0x00f2)
#define MI_MAIN_HELP_KEYS    (MI_FILE + 0x00f3)
#define MI_MAIN_HELP_USING   (MI_FILE + 0x00f4)


#define STR_IDLE_STATUS  (MI_FILE + 0x00FF)

//**************************************************************************
// ICON IDs
//**************************************************************************
#define ICN_HOST         0x1300
#define ICN_GROUP        0x1301
#define ICN_SUBSGRP      0x1302
#define ICN_BRANCH       0x1303

//**************************************************************************
// Dialog IDs - window IDs used in ATextDialog class                       *
//**************************************************************************
#ifndef DID_OK                          //If not already defined by OS/2,
#define DID_OK           0x0001         //OK button command ID
#endif                                  //
#ifndef DID_CANCEL                      //If not already defined by OS/2
#define DID_CANCEL       0x0002         //Cancel button command ID
#endif                                  //

//**************************************************************************
// Dialog IDs - GetString Window
//**************************************************************************

#define WND_GETSTRING         0x2000
#define WND_GETSTR_CLIENT     (WND_GETSTRING + 0x0001)
#define WND_GETSTR_MSG        (WND_GETSTRING + 0x0002)
#define WND_GETSTR_STR        (WND_GETSTRING + 0x0003)
#define BUT_GETSTR_OK         (WND_GETSTRING + 0x0004)
#define BUT_GETSTR_CANCEL     (WND_GETSTRING + 0x0005)
#define WND_GETSTR_BUTTONS    (WND_GETSTRING + 0x0006)

//**************************************************************************
// Dialog IDs - SuckArticles Window
//**************************************************************************

#define WND_SUCK            0x3000
#define WND_SUCK_CLIENT     (WND_SUCK + 0x0001)
#define WND_SUCK_MSG        (WND_SUCK + 0x0002)
#define WND_SUCK_STR        (WND_SUCK + 0x0003)
#define BUT_SUCK_CANCEL     (WND_SUCK + 0x0005)

//**************************************************************************
// Dialog IDs - Expire Settings
//**************************************************************************

#define WND_EXPIRE_SETTINGS 0x4000
// +1 and +2 are used by OkCancelWindow
#define WND_EXPIRE_MSG      (WND_EXPIRE_SETTINGS + 0x0003)
#define WND_EXPIRE_DAYS     (WND_EXPIRE_SETTINGS + 0x0004)
#define WND_EXPIRE_ARTS     (WND_EXPIRE_SETTINGS + 0x0005)
#define WND_EXPIRE_SIZE     (WND_EXPIRE_SETTINGS + 0x0006)
#define WND_EXPIRE_DAYS_TXT (WND_EXPIRE_SETTINGS + 0x0007)
#define WND_EXPIRE_ARTS_TXT (WND_EXPIRE_SETTINGS + 0x0008)
#define WND_EXPIRE_SIZE_TXT (WND_EXPIRE_SETTINGS + 0x0009)
#define WND_EXPIRE_TITLE    (WND_EXPIRE_SETTINGS + 0x000a)
#define WND_EXPIRE_MESSAGE  (WND_EXPIRE_SETTINGS + 0x000b)


/*
 * $Log: changi_l.h,v $
 * Revision 1.14  1997/04/05 16:56:59  oliver
 * various bugfixes
 *
 * Revision 1.13  1997/03/19 14:41:33  oliver
 * added caching to allGroupCnr
 *
 * Revision 1.12  1997/03/18 16:12:40  oliver
 * bugfixes
 * menu changet to resource
 * help added
 * profile for Window-position added
 *
 * Revision 1.11  1997/03/17 12:36:13  oliver
 * added popupmenus
 *
 * Revision 1.10  1997/03/02 16:08:55  Oliver
 * please
 *
 * Revision 1.9  1997/03/01 18:43:42  oliver
 * tried, but threads don't do well
 *
 * Revision 1.8  1997/02/18 16:14:17  oliver
 * added helpwindow
 *
 * Revision 1.7  1997/02/14 17:25:10  oliver
 * added button and menu for expiry settings
 *
 * Revision 1.6  1997/02/14 17:01:48  oliver
 * added dialog for expiry options
 *
 * Revision 1.5  1997/02/14 15:03:58  oliver
 * adding a host is now refued, if the host already exists in the list
 *
 * Revision 1.4  1997/02/14 14:44:34  oliver
 * added errormessages to resourcefile
 * now asking for confirmation if config is not saved before sucking articles
 *
 * Revision 1.3  1997/02/14 12:17:09  oliver
 * added new generic OkCancelDialog
 * addHost now refuses to add a host with name
 *
 * Revision 1.2  1997/02/14 10:33:53  oliver
 * made Id-Headers into one file: changi_l.h
 *
 * Revision 1.1  1997/02/13 13:58:55  oliver
 * initial revision
 */

#endif
