#ifndef EXPIRESETTINGS_HPP
#define EXPIRESETTINGS_HPP

/*
 * $Id: expiresettings.hpp,v 1.2 1997/03/10 18:39:07 oliver Exp $
 */

// Align classes on four byte boundary.
#pragma pack(4)

#include <istattxt.hpp>
#include <ientryfd.hpp>
#include <icnrctl.hpp>

#include "okcanceldialog.hpp"
class Expiration;
class GroupCnrObj;

class ExpireSettings : public OkCancelDialog
{
 public:
   ExpireSettings(IWindow* parent, const Expiration& exp);
   virtual ~ExpireSettings();

 protected:
   IStaticText message_;
   IEntryField days_;
   IEntryField arts_;
   IEntryField size_;
   IStaticText daystext_;
   IStaticText artstext_;
   IStaticText sizetext_;
};

class ExpireSettingsOnce : public ExpireSettings
{
 public:
   ExpireSettingsOnce(IWindow* parent, GroupCnrObj& obj);

   virtual void doIt();
 private:
   GroupCnrObj& obj_;
};

class ExpireSettingsMany : public ExpireSettings
{
 public:
   ExpireSettingsMany(IWindow* parent, ICnrCtl& container,
                      ICnrCtl::ObjectCursor& cursor);

   virtual void doIt();
 private:
   ICnrCtl& container_;
   ICnrCtl::ObjectCursor& cursor_;
   Expiration getDefault(ICnrCtl& container, ICnrCtl::ObjectCursor& cursor);
};

// Resume compiler default packing.
#pragma pack()

/*
 * $Log: expiresettings.hpp,v $
 * Revision 1.2  1997/03/10 18:39:07  oliver
 * add/removeGroup Buttons now work again
 * changeSettings now also for multiple Groups
 *
 * Revision 1.1  1997/02/14 17:01:53  oliver
 * added dialog for expiry options
 *
 */

#endif
