const char getstringwindow_rcsid[] =
"$Id: getstringwindow.cpp,v 1.4 1997/04/05 16:57:02 oliver Exp $";

#include <istring.hpp>
#include <itrace.hpp>

#include "getstringwindow.hpp"

#include "changi_l.h" // Resource Definitions

GetStringWindow::GetStringWindow(IWindow* parent, const IString& title, const IString& message)
   : OkCancelDialog(WND_GETSTRING, parent, title)
   , message_(WND_GETSTR_MSG, &clientCanvas, this)
   , string_(WND_GETSTR_STR, &clientCanvas, this, IRectangle(),
      IEntryField::classDefaultStyle
      | IControl::tabStop )
   {
   IFUNCTRACE_DEVELOP();
   clientCanvas
      .addToCell(&message_,2,2,1,1)
      .addToCell(&string_,2,3,1,1)
      .setColumnWidth(2,0,true)
      .setColumnWidth(3,5,false)
      .setRowHeight(4,5,false)
      .setBackgroundColor(IColor::paleGray);
   message_
      .setText(message)
      .setBackgroundColor(IColor::paleGray);

   moveSizeToClient(IRectangle(IPoint(),clientCanvas.minimumSize()));
   moveTo(parent->position()+parent->size()/2-size()/2);

   string_.setFocus();
   ICommandHandler::handleEventsFor(this);
   }

GetStringWindow::~GetStringWindow()
   {
   IFUNCTRACE_DEVELOP();
   ICommandHandler::stopHandlingEventsFor(this);
   }

/*
 * $Log: getstringwindow.cpp,v $
 * Revision 1.4  1997/04/05 16:57:02  oliver
 * various bugfixes
 *
 * Revision 1.3  1997/02/14 12:17:09  oliver
 * added new generic OkCancelDialog
 * addHost now refuses to add a host with name
 *
 * Revision 1.2  1997/02/13 19:19:27  oliver
 * allGroupsContainer now recognizes subsription status
 *
 * Revision 1.1  1997/02/13 13:58:58  oliver
 * initial revision
 *
 */


