#ifndef GROUPCNR_HPP
#define GROUPCNR_HPP

/*
 * $Id: groupcnr.hpp,v 1.5 1997/04/05 16:57:03 oliver Exp $
 */

// Align classes on four byte boundary.
#pragma pack(4)

#include <icnrctl.hpp>
#include <icnrhdr.hpp>
#include <icnrmhdr.hpp>
#include <ipopmenu.hpp>
#include <iseq.h>

#include "Changi_L.h"
class HostCnrObj;
class GroupCnrObj;
class IContainerColumn;

//****************************************************************************
//   GroupCnr
//****************************************************************************

class GroupCnr : public IContainerControl
               , protected ICnrHandler
               , public ICnrMenuHandler
{
 public:
   GroupCnr(unsigned long id, IWindow* parent, IWindow* owner);
   virtual ~GroupCnr();

 protected:
   virtual Boolean makePopUpMenu(IMenuEvent& menuEvent);
   IContainerColumn* groupIconColumn;
   IContainerColumn* groupNameColumn;

 private:
   IPopUpMenu popUp;
};

//****************************************************************************
//   AllGroupCnr
//****************************************************************************

class AllGroupCnr : public GroupCnr
{
 public:
   AllGroupCnr(unsigned long id, IWindow* parent, IWindow* owner);
   virtual ~AllGroupCnr();
   void setGroupList(const ISequence<GroupCnrObj*> & newList);

 protected:
   virtual Boolean deltaReached(ICnrQueryDeltaEvent& event);

 private:
   IContainerColumn* groupDiscrColumn;
   ISequence<GroupCnrObj*> groupList;
   unsigned long cache_offset;
   unsigned long numberOfElements;
   void cacheTo(unsigned long new_offset);
};

// Resume compiler default packing.
#pragma pack()

/*
 * $Log: groupcnr.hpp,v $
 * Revision 1.5  1997/04/05 16:57:03  oliver
 * various bugfixes
 *
 * Revision 1.4  1997/03/19 14:41:35  oliver
 * added caching to allGroupCnr
 *
 * Revision 1.3  1997/03/17 12:36:14  oliver
 * added popupmenus
 *
 * Revision 1.2  1997/03/01 18:43:44  oliver
 * tried, but threads don't do well
 *
 * Revision 1.1  1997/02/13 13:59:00  oliver
 * initial revision
 *
 */

#endif
