#ifndef HOSTCNR_HPP
#define HOSTCNR_HPP

/*
 * $Id: hostcnr.hpp,v 1.4 1997/04/05 16:57:04 oliver Exp $
 */

// Align classes on four byte boundary.
#pragma pack(4)

#include <icnrctl.hpp>
#include <icmdhdr.hpp>
#include <icnrhdr.hpp>
#include <icnrmhdr.hpp>
#include <istring.hpp>

#include "rmtlink.h"

class HostCnrObj;

//**************************************************************************
//   HostCnr
//**************************************************************************

class HostCnr : public IContainerControl
              , public ICnrHandler
              , public ICnrMenuHandler
{
 public:
   HostCnr(unsigned long id, IWindow* parent, IWindow* owner);
   virtual ~HostCnr();

   HostCnrObj* selectedHost();
   HostCnrObj* cursoredHost();

   void loadHosts();
   void saveHostConfig();
   void addHost();
   void addHost(const IString& hostName);
   void removeHost(HostCnrObj* host);
   void suckListForHost(HostCnrObj* host);
   void suckArtsForHost(HostCnrObj* host);

   Boolean configDirty();

 protected:
   virtual Boolean makePopUpMenu(IMenuEvent& menuEvent);

 private:
    RMTLINK*          hostsRoot;
};

// Resume compiler default packing.
#pragma pack()

/*
 * $Log: hostcnr.hpp,v $
 * Revision 1.4  1997/04/05 16:57:04  oliver
 * various bugfixes
 *
 * Revision 1.3  1997/03/17 12:36:15  oliver
 * added popupmenus
 *
 * Revision 1.2  1997/03/01 18:43:45  oliver
 * tried, but threads don't do well
 *
 * Revision 1.1  1997/03/01 11:53:27  oliver
 * added hostcnr
 *
 */

#endif
