/*
 * $Id: messagewnd.cpp,v 1.4 1997/04/05 16:57:06 oliver Exp $
 */

#include <iframe.hpp>
#include <ifont.hpp>
#include <itrace.hpp>

#include "messagewnd.hpp"

MessageWnd::MessageWnd(IWindow* parent, const IString& message)
   : IFrameWindow(IC_DEFAULT_FRAME_ID, 0, parent,
      IRectangle(parent->position()+parent->size()/2-ISize(400,100)/2,ISize(400,100)),
      IWindow::visible | IFrameWindow::dialogBorder | IFrameWindow::dialogBackground)
   , message_(0,this,this)
   {
   IFUNCTRACE_DEVELOP();
   setDestroyOnClose();
   setAutoDeleteObject();
   setClient(&message_);
   message_
      .setAlignment(IStaticText::centerCenter)
      .setText(message);
#ifdef __WINDOWS__
   setFont(IFont("Helv",8));
#endif
   }

/*
 * $Log: messagewnd.cpp,v $
 * Revision 1.4  1997/04/05 16:57:06  oliver
 * various bugfixes
 *
 * Revision 1.3  1997/03/18 16:12:45  oliver
 * bugfixes
 * menu changet to resource
 * help added
 * profile for Window-position added
 *
 * Revision 1.2  1997/03/10 18:39:08  oliver
 * add/removeGroup Buttons now work again
 * changeSettings now also for multiple Groups
 *
 */
