const char okcanceldialog_rcsid[] =
"$Id: okcanceldialog.cpp,v 1.5 1997/04/05 16:57:06 oliver Exp $";

#include <istring.hpp>
#include <itrace.hpp>
#include <ititle.hpp>
#include <ifont.hpp>
#include <icolor.hpp>

#include "okcanceldialog.hpp"

#include "changi_l.h" // Resource Definitions

OkCancelDialog::OkCancelDialog(unsigned long Id, IWindow* parent, const IString& title)
   : IFrameWindow(Id, parent)
   , clientCanvas(Id+1, this, this)
   , buttonCanvas_(Id+2, this, this)
   , ok_(DID_OK, &buttonCanvas_, this, IRectangle(),
         IPushButton::classDefaultStyle
         | IPushButton::defaultButton
         | IControl::group
         | IControl::tabStop)
   , cancel_(DID_CANCEL, &buttonCanvas_, this, IRectangle(),
         IPushButton::classDefaultStyle
         | IControl::group
         | IControl::tabStop)
   {
   IFUNCTRACE_DEVELOP();
   setAutoDeleteObject();
#ifdef __WINDOWS__
   setFont(IFont("Helv",8));
#endif
   setBackgroundColor(IColor::paleGray);
   ITitle(this,title);

   setClient(&clientCanvas);
   addExtension(&buttonCanvas_, belowClient);

   ok_.setText(IApplication::current().userResourceLibrary().loadString(DID_OK));
   cancel_.setText(IApplication::current().userResourceLibrary().loadString(DID_CANCEL));

   ICommandHandler::handleEventsFor(this);
   }

OkCancelDialog::~OkCancelDialog()
   {
   IFUNCTRACE_DEVELOP();
   ICommandHandler::stopHandlingEventsFor(this);
   }

Boolean OkCancelDialog::command(ICommandEvent& cmdEvent)
   {
   IFUNCTRACE_DEVELOP();

   if(cmdEvent.commandId() == DID_OK)
      {
      doIt();
      close();
      return true;
      }
   if(cmdEvent.commandId() == DID_CANCEL)
      {
      close();
      return true;
      }

   return false;
   }

/*
 * $Log: okcanceldialog.cpp,v $
 * Revision 1.5  1997/04/05 16:57:06  oliver
 * various bugfixes
 *
 * Revision 1.4  1997/03/18 16:12:46  oliver
 * bugfixes
 * menu changet to resource
 * help added
 * profile for Window-position added
 *
 * Revision 1.3  1997/03/10 18:39:09  oliver
 * add/removeGroup Buttons now work again
 * changeSettings now also for multiple Groups
 *
 * Revision 1.2  1997/02/14 17:01:55  oliver
 * added dialog for expiry options
 *
 * Revision 1.1  1997/02/14 12:17:11  oliver
 * added new generic OkCancelDialog
 * addHost now refuses to add a host with name
 *
 */


