const char suckartsthread_rcsid[] =
"$Id: suckartsthread.cpp,v 1.1 1997/04/09 12:23:31 oliver Exp $";

#include <imsgbox.hpp>

#include "suckartsthread.hpp"
#include "suckwindow.hpp"
#include "hostcnrobj.hpp"
#include "hostcnr.hpp"
#include "changi_l.h"
#include "changi_l.hpp"
#include "..\include\suckarts.h"
#include "..\include\sysdep.h"

//****************************************************************************
//   SuckArticlesThread
//****************************************************************************

IBoolean SuckArticlesThread::startThread(IWindow* parent, HostCnrObj* host)
   {
   if (alreadyRunning) // only one allowed
      {
      IMessageBox(parent)
         .show(
            IApplication::current().userResourceLibrary().loadString(ERR_SUCK_RUNNING),
            IMessageBox::errorIcon | IMessageBox::okButton );
      return false;
      }
   else
      {
      if (HostCnrObj::isDirty())
         {
         IMessageBox::Response answer = IMessageBox(ChangiLWindow::getMainWindow()).show(
            IApplication::current().userResourceLibrary().loadString(STR_SAVE_CONFIG),
            IMessageBox::queryIcon | IMessageBox::yesNoCancelButton);
         if (answer  == IMessageBox::yes)
            ((HostCnr&)ChangiLWindow::getMainWindow()->getHostCnr()).saveHostConfig();
         else if (answer  == IMessageBox::cancel)
            return true;
         }
      alreadyRunning = true;
      IThread suck( new SuckArticlesThread(parent, host), true);
      }
   return true;
   }

SuckArticlesThread::SuckArticlesThread(IWindow* parent, HostCnrObj* host)
   : IThreadFn()
   , parent_(parent)
   , host_(host)
   {
   suckWindow_ = new SuckWindow(ChangiLWindow::getMainWindow());
   suckWindow_->show();
   timer_ = new ITimer(new SuckArticlesTimer(suckWindow_));
   }

SuckArticlesThread::~SuckArticlesThread()
   {
   delete timer_;
   suckWindow_->close();
   // delete suckWindow_; passiert automatisch.
   }

void SuckArticlesThread::run()
   {
   try
      {
      int err = suck_articles(host_->iconText());
      if (err) IMessageBox(parent_)
         .show(
         IApplication::current().userResourceLibrary().loadString(ERR_SUCK_ARTS),
         IMessageBox::errorIcon | IMessageBox::okButton);
         }
   catch (IException e) { IMessageBox(parent_).show(e); }
   alreadyRunning = false;
   }

IBoolean SuckArticlesThread::alreadyRunning = false;

//****************************************************************************
//   SuckArticlesTimer
//****************************************************************************

SuckArticlesTimer::SuckArticlesTimer(SuckWindow* window)
   : ITimerFn()
   , window_(window)
   {
   }

void SuckArticlesTimer::timerExpired(unsigned long)
   {
   try
      {
      char buffer[265];
      if (!stat_artsucker(buffer))
         window_->setText(buffer);
      }
   // ### Welche Exception wird hier aufgeworfen?
   catch(...) {}
   }

/*
 * $Log: suckartsthread.cpp,v $
 * Revision 1.1  1997/04/09 12:23:31  oliver
 * moved thead-classes to individual files
 *
 *
 */


