#ifndef SUCKARTSTHREAD_HPP
#define SUCKARTSTHREAD_HPP

/*
 * $Id: suckartsthread.hpp,v 1.1 1997/04/09 12:23:31 oliver Exp $
 */

// Align classes on four byte boundary.
#pragma pack(4)

#include <ithread.hpp>
#include <itimer.hpp>

class HostCnrObj;

//****************************************************************************
//   SuckArticlesThread
//****************************************************************************

class SuckWindow;

class SuckArticlesThread : public IThreadFn
{
 public:
   static startThread(IWindow* parent, HostCnrObj* host);
   ~SuckArticlesThread();
   virtual void run();
 private:
   SuckArticlesThread(IWindow* parent, HostCnrObj* host);
   static IBoolean alreadyRunning;
   IWindow* parent_;
   HostCnrObj* host_;
   SuckWindow* suckWindow_;
   ITimer* timer_;
};


//****************************************************************************
//   SuckArticlesTimer
//****************************************************************************

class SuckWindow;

class SuckArticlesTimer : public ITimerFn
{
 public:
   SuckArticlesTimer(SuckWindow* window);
   virtual void timerExpired(unsigned long timerId);
 private:
   SuckWindow* window_;
};

// Resume compiler default packing.
#pragma pack()

/*
 * $Log: suckartsthread.hpp,v $
 * Revision 1.1  1997/04/09 12:23:31  oliver
 * moved thead-classes to individual files
 *
 *
 */

#endif
