const char suckwindow_rcsid[] =
"$Id: suckwindow.cpp,v 1.4 1997/04/05 16:57:07 oliver Exp $";

#include <istring.hpp>
#include <itrace.hpp>
#include <ifont.hpp>
#include <ititle.hpp>

#include "changi_l.h" // Resource Definitions
#include "suckwindow.hpp"
#include "hostcnrobj.hpp"
#include "..\include\suckarts.h"

SuckWindow::SuckWindow(IWindow* parent)
   : IFrameWindow(WND_SUCK)
   , clientCanvas(WND_SUCK_CLIENT, this, this)
   , message_(WND_SUCK_MSG, &clientCanvas, this)
   , string_(WND_SUCK_STR, &clientCanvas, this)
   , cancel_(BUT_SUCK_CANCEL, &clientCanvas, this, IRectangle(),
         IPushButton::classDefaultStyle | IPushButton::defaultButton)
   {
   IFUNCTRACE_DEVELOP();
#ifdef __WINDOWS__
   setFont(IFont("Helv",8));
#endif
   setBackgroundColor(IColor::paleGray);
   ITitle(this,IApplication::current().userResourceLibrary().loadString(WND_SUCK));
   setClient(&clientCanvas);
   clientCanvas
      .addToCell(&message_,2,2,3,3)
      .addToCell(&string_,3,3,1,1)
      .addToCell(&cancel_,2,6,3,1)
      .setColumnWidth(3,0,true)
      .setColumnWidth(5,5,false)
      .setRowHeight(2,20,false)
      .setRowHeight(3,0,true)
      .setRowHeight(7,5,false)
      .setBackgroundColor(IColor::paleGray);
   message_.setText(IApplication::current().userResourceLibrary().loadString(WND_SUCK_MSG));
   cancel_.setText(IApplication::current().userResourceLibrary().loadString(BUT_SUCK_CANCEL));

   moveSizeToClient(IRectangle(IPoint(),ISize(400, clientCanvas.minimumSize().height())));
   moveTo(parent->position()+parent->size()/2-size()/2);

   ICommandHandler::handleEventsFor(this);
   }

SuckWindow::~SuckWindow()
   {
   IFUNCTRACE_DEVELOP();
   ICommandHandler::stopHandlingEventsFor(this);
   }

Boolean SuckWindow::command(ICommandEvent& cmdEvent)
   {
   IFUNCTRACE_DEVELOP();

   if(cmdEvent.commandId() == BUT_SUCK_CANCEL)
      {
      stop_artsucker();
      return true;
      }

   return false;
   }

/*
 * $Log: suckwindow.cpp,v $
 * Revision 1.4  1997/04/05 16:57:07  oliver
 * various bugfixes
 *
 * Revision 1.3  1997/03/18 16:12:46  oliver
 * bugfixes
 * menu changet to resource
 * help added
 * profile for Window-position added
 *
 * Revision 1.2  1997/02/14 10:40:24  oliver
 * made all Resource Headers into one file: changi_l.h
 *
 * Revision 1.1  1997/02/13 13:59:01  oliver
 * initial revision
 *
 */


