#ifndef ARTICLE_H
#define ARTICLE_H

/*----------------------------------------------------------------------*/
/* Copyright (c) 1996 by Harald Kipp. All rights reserved.              */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/* This software was originally based on the RNEWS program written by   */
/* Mike Lipsie.                                                         */
/*                                                                      */
/* Parts are copyright by Kendra Electronic Wonderworks.                */
/*                                                                      */
/* Send bug reports to                                                  */
/*                                                                      */
/*      harald@os2point.ping.de                                         */
/*                                                                      */
/*----------------------------------------------------------------------*/

/*
 * $Id: article.h,v 1.1 1997/02/13 14:00:56 oliver Exp $
 */

typedef enum _KEYIDX {
    ID_Newsgroups   ,
    ID_X_Newsgroups ,
    ID_Path         ,
    ID_From         ,
    ID_Subject      ,
    ID_References   ,
    ID_Followup_To  ,
    ID_Approved     ,
    ID_Organization ,
    ID_Date         ,
    ID_Message_ID   ,
    ID_Keywords     ,
    ID_Summary      ,
    ID_Expires      ,
    ID_Reply_To     ,
    ID_Distribution ,
    ID_Control      ,
    ID_Sender       ,
    ID_Lines        ,
    ID_Xref         ,
    ID_LASTENTRY
} KEYIDX;

typedef struct {
    char   *name;
    KEYIDX idx;
} KEYWORD;

typedef struct {
    char *key;
    char *info;
} HEADER;

typedef struct _BODY {
    struct _BODY *next;
    char *line;
} BODY;


size_t _System ChanReadHeader(FILE *fp, char *buf, size_t *bufsiz, HEADER *header);
int _System ChanReadBody(FILE *fp, BODY **body, size_t nbytes);
int _System ChanAddArticle(HEADER *header, BODY *body, char *myhost);

/*
 * $Log: article.h,v $
 * Revision 1.1  1997/02/13 14:00:56  oliver
 * initial revision
 *
 * Revision 1.1  1997/02/13  10:07:45  oliver
 * initial revision
 *
 */

#endif
