#ifndef ACCESS_H
#define ACCESS_H

/*
 * $Id: access.h,v 1.1 1997/02/13 14:03:26 oliver Exp $
 */

/*----------------------------------------------------------------------*/
/* Host access permissions                                              */
/*                                                                      */
/*----------------------------------------------------------------------*/
typedef struct {
    int  canpost;       /* set if host has permission to post       */
    int  canread;       /* set if host has permission to read       */
    int  canxfer;       /* set if host has permission to transfer   */
    int  needreadauth;  /* set if host needs authorization to read  */
    int  needpostauth;  /* set if host needs authorization to post  */

    /*
     * 10/26/1996 harald
     * Changed access permissions to pattern matching
     */
    char *ngaccess;     /* comma separated list of accessable groups  */
    char *ngreadonly;   /* comma separated list of posting exclusions */
} ACCESSPERMS;

int host_access(char *accessfile, char *remotehost,
                long remoteaddr, ACCESSPERMS *perms);
int user_access(char *accessfile, char *username,
                char *password, ACCESSPERMS *perms);
int ctrl_perms(char *accessfile, void *from,
               char *username, char *permissions);
int team_access(char *accessfile, char *remotehost,
                long remoteaddr, char *group, int mode);

/*
 * $Log: access.h,v $
 * Revision 1.1  1997/02/13 14:03:26  oliver
 * initial revision
 *
 * Revision 1.1  1997/02/13  10:05:31  oliver
 * initial revision
 *
 */

#endif
