#ifndef ARTICLE_H
#define ARTICLE_H

/*
 * $Id$
 *
 * $Log$
 */


#include "linbuf.h"
#include "hdrlines.h"

/*---------------------------------------------------------------------*/
/* This structure is allocated for each client connection and          */
/* reused for each incoming article.                                   */
/*---------------------------------------------------------------------*/
typedef struct _ARTICLE {
    HEADER header[ID_LASTENTRY + MAX_XHEADER];  /* Pointers into headbuf */
    LINBUF *headbuf;
    LINBUF *bodybuf;

    int    hopcount;        /* number of hosts in path header */
    char   *pathinfo;       /* copy of path header, converted to lower case */
    char   **pathlist;      /* list of path hosts, pointers to 'pathinfo' */

    char   *distribinfo;
    char   **distriblist;

    char   n_groups;
    char   *groupsinfo;
    char   **groupslist;

    char   n_followups;
    char   *groupsmode;
    int    validgroups;
    int    moderated;

    int    firstgroup;
    int    nxrefs;
    int    xxrefs;
    char   **xrefs;
    long   *xrefnums;

    char   x_control[40];
    char   *fromhost;

    long   artsize;
    long   posted;      /* posting date */
    long   arrived;
    long   expires;
} ARTICLE;

/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/
extern int parse_header(ARTICLE *artp);
extern int want_distrib(char **list, char *dist);
extern int inspect_article(ARTICLE *artp, char *poster, char **exclusions, char **distribs);
extern void init_article(ARTICLE *artp, char *remotehost);
extern void free_article(ARTICLE *artp);
extern long article_size(ARTICLE *artp, int with_xref);
extern long spew_article(FILE *fp, ARTICLE *artp, char *batched, int linked, int with_xref);
extern int file_article(ARTICLE *artp);
extern int addhistart(ARTICLE *artp);

#endif
