#ifndef CONFIG_H
#define CONFIG_H

/*
 * $Id$
 */
/*
 * $Log$
 */


#include <chlimits.h>

/*----------------------------------------------------------------------*/
/*  Configuration                                                       */
/*                                                                      */
/*----------------------------------------------------------------------*/
typedef struct _CONFIG {
    char workdir[_MAX_PATH];

    char pidfile[_MAX_PATH];
    char newsdir[_MAX_PATH];
    char overdir[_MAX_PATH];
    char activefile[_MAX_PATH];
    char active_times[_MAX_PATH];
    char distributionsfile[_MAX_PATH];
    char newsgroupsfile[_MAX_PATH];
    char subscriptionsfile[_MAX_PATH];
    char overviewfmtfile[_MAX_PATH];    /* added 07/09/1996 harald */
    char newsfeedsfile[_MAX_PATH];
    char historyfile[_MAX_PATH];
    char seqf[_MAX_PATH];           /* seqf file pathname */
    char mailpathsfile[_MAX_PATH];
    char spooldir[_MAX_PATH];
    char tempdir[_MAX_PATH];        /* added 08/07/1996 harald */

    char chartranfile[_MAX_PATH];
    char signfile[_MAX_PATH];
    char controlfile[_MAX_PATH];        /* added 07/25/1997 harald */

    char rnewscall[_MAX_PATH];
    char smailcall[_MAX_PATH];
    char grepcall[_MAX_PATH];
    char compresscall[_MAX_PATH];
    char compressintro[128];            /* added 08/02/97 harald */
    char uncompresscall[_MAX_PATH];     /* added 08/30/97 harald */
    char gunzipcall[_MAX_PATH];         /* added 08/30/97 harald */

    char junkgroup[MAX_NGNAME];
    char dupegroup[MAX_NGNAME];
    char controlgroup[MAX_NGNAME];

    char hostaccessfile[_MAX_PATH];     /* added 10/26/1996 harald */
    char useraccessfile[_MAX_PATH];
    char ctrlaccessfile[_MAX_PATH];
    char teamaccessfile[_MAX_PATH];     /* added 07/22/1997 harald */
    char groupdistribfile[_MAX_PATH];   /* added 09/01/1996 harald */

    char mynode[MAX_NODENAME];      /* local node name without domain */
    char mydomain[MAX_DOMAINNAME];  /* local node name including domain */
    char pathhost[MAX_DOMAINNAME];  /* local node name to build path line */
    char newsmaster[MAX_DOMAINNAME];
    char pathmaster[MAX_DOMAINNAME];
    char newsserver[MAX_DOMAINNAME];

    char organization[MAX_CLPSIZE]; /* overwrite organization line */
    char mimeversion[MAX_CLPSIZE];
    char mimetype[MAX_CLPSIZE];
    char mimeencoding[MAX_CLPSIZE];
    char distribution[MAX_CLPSIZE];
    char welcome[MAX_CLPSIZE];

    char logname[128];              /* added 08/07/1996 harald */
    char newsadmin[128];            /* added 07/20/97 harald */
    char newsport[128];
    char controlport[128];
    char headerdummy[32];

    char autoflush[32];
    char controlctldelimit[16];     /* added 08/03/97 harald */

    int  char_translate;
    int  emulate_links;
    int  local_replygroup;
    int  queue_incoming;
    int  auto_dequeue;
    int  max_quotelines;
    int  force_followup;

    int  max_threads;
    int  max_clients;
    long max_load;
    long min_free;
    long min_core;

    unsigned long logflg;
    long sockwait;                  /* client timeout  */
} CONFIG, *PCONFIG;


extern CONFIG cfg;


extern void init_cfg(void);
extern int validate_cfg(void);
extern int dump_cfg(void);

/*----------------------------------------------------------------------*/
/*  Logging flags                                                       */
/*----------------------------------------------------------------------*/
#define LOG_FLUSH   0x00000001L
#define LOG_RECV    0x00000002L
#define LOG_SEND    0x00000004L
#define LOG_DBM     0x00000008L
#define LOG_ACTIVE  0x00000010L
#define LOG_CMDFAIL 0x00000020L
#define LOG_TCPFAIL 0x00000040L
#define LOG_ACCOUNT 0x00000080L

/*
 * New with version 0.9p
 */
#define LOG_FEEDINI 0x00000100L
#define LOG_FEED    0x00000200L
#define LOG_PERM    0x00000400L
#define LOG_HEAP    0x00000800L
#define LOG_CONFIG  0x00001000L
#define LOG_DUPES   0x00002000L
#define LOG_JUNK    0x00004000L
#define LOG_OVER    0x00008000L
#define LOG_BATCH   0x00010000L

#define LOG_DISTRIB 0x00010000L

#define dolog(x)    (cfg.logflg & (unsigned long)(x))

#endif
