#ifndef HDRLINES_H
#define HDRLINES_H

/*
 * $Id: hdrlines.h,v 1.1 1997/02/13 14:03:41 oliver Exp $
 */

typedef enum _KEYIDX {
    ID_Path                     ,
    ID_From                     ,
    ID_Newsgroups               ,
    ID_Subject                  ,
    ID_Control                  ,
    ID_Supersedes               ,
    ID_Followup_To              ,
    ID_Date                     ,
    ID_Organization             ,
    ID_Lines                    ,
    ID_Sender                   ,
    ID_Approved                 ,
    ID_Distribution             ,
    ID_Expires                  ,
    ID_Message_ID               ,
    ID_References               ,
    ID_Reply_To                 ,
    ID_NNTP_Posting_Host        ,
    ID_Mime_Version             ,
    ID_Content_Type             ,
    ID_Content_Transfer_Encoding,
    ID_Xref                     ,
    ID_Summary                  ,
    ID_Keywords                 ,
    ID_Date_Received            ,
    ID_Received                 ,
    ID_Posted                   ,
    ID_Posting_Version          ,
    ID_Relay_Version            ,
    ID_X_Newsgroups             ,
    ID_Bytes                    ,
    ID_LASTENTRY
} KEYIDX;

typedef struct {
    char *key;
    char *info;
} HEADER;

typedef enum {
    HO_REMOVE,      /* Silently remove this header       */
    HO_IGNORE ,     /* Optional known header             */
    HO_MUSTHAVE,    /* Drop articles without this header */
    HO_DONTWANT     /* Drop articles with this header    */
} HOPTION;

typedef struct {
    char   *name;       /* name of the header line (without colon) */
    KEYIDX  idx;        /* 'KEYIDX' value, see above */
    HOPTION in_xfer;    /* how to check with IHAVE */
    HOPTION in_post;    /* how to check with POST */
    int     acpt_dupes; /* 1, if duplicate headers accepted */
} KEYWORD;

extern KEYWORD hdkey[];
extern int nhdkeys;

/*
 * $Log: hdrlines.h,v $
 * Revision 1.1  1997/02/13 14:03:41  oliver
 * initial revision
 *
 * Revision 1.1  1997/02/13  10:05:43  oliver
 * initial revision
 *
 */

#endif
