#ifndef LINBUF_H
#define LINBUF_H

/*
 * $Id: linbuf.h,v 1.1 1997/02/13 14:03:43 oliver Exp $
 */

/*----------------------------------------------------------------------*/
/*  Dynamic line buffers                                                */
/*----------------------------------------------------------------------*/

typedef struct {
    char   *data;   /* pointer to buffer storage        */
    size_t size;    /* current size of buffer           */
    size_t used;    /* number of occupied buffer bytes  */
    size_t *offset; /* array of line offsets            */
    int    alines;  /* number of available line offsets */
    int    nlines;  /* number of used line offsets      */
    int    inheap;  /* set to 1 if struct was allocated */
} LINBUF;

#define LBPTR(x, n) (x->data + x->offset[n])

extern LINBUF *linbuf_create(LINBUF *bp);
extern LINBUF *linbuf_destroy(LINBUF *bp);
extern void linbuf_clear(LINBUF *bp);
extern char *linbuf_add(LINBUF *bp, const char *line);
extern char *linbuf_append(LINBUF *bp, const char *line, char delim);
extern int check_maxquote(LINBUF *bodybuf, int limit);

/*
 * $Log: linbuf.h,v $
 * Revision 1.1  1997/02/13 14:03:43  oliver
 * initial revision
 *
 * Revision 1.1  1997/02/13  10:05:45  oliver
 * initial revision
 *
 */

#endif
