/*----------------------------------------------------------------------*/
/* Copyright (c) 1996 by Harald Kipp. All rights reserved.              */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/* This software was originally based on the                            */
/*                                                                      */
/*      Network News Transfer Protocol server                           */
/*                                                                      */
/*      Phil Lapsley                                                    */
/*      University of California, Berkeley                              */
/*      Stan Barber                                                     */
/*      Baylor College of Medicine                                      */
/*                                                                      */
/* Send bug reports to                                                  */
/*                                                                      */
/*      harald@os2point.ping.de                                         */
/*                                                                      */
/*----------------------------------------------------------------------*/

/*
 *
 * This module contains routines to detect availability
 * of certain system resources.
 *
 */

const char ntrescl_rcsid[] = "$Id: ntrescl.c,v 1.1 1997/02/13 14:03:51 oliver Exp $";

#include <windows.h>

#include <stdlib.h>
#include <process.h>
#include <ctype.h>

#include <syslog.h>

#include "rescalc.h"

// static ULONG average = 31;

/************************************************************************/
/*                                                                      */
/************************************************************************/
long mbytes_avail(char *pathname)
{
#if 0
    ULONG bytes;
    APIRET rc;

    if(pathname == NULL) {
        rc = DosQuerySysInfo(QSV_TOTAVAILMEM, QSV_TOTAVAILMEM, &bytes, sizeof(bytes));
        if(rc)
            return(-1);
    }
    else {
        char drive[_MAX_DRIVE];
        FSALLOCATE fsa;
        ULONG disknum = 0;

        _splitpath(pathname, drive, NULL, NULL, NULL);
        if(drive[0])
            disknum = toupper(drive[0]) - '@';
        rc = DosQueryFSInfo(disknum, FSIL_ALLOC, &fsa, sizeof(fsa));
        if(rc)
            return(-1);
        bytes = fsa.cUnitAvail * fsa.cSectorUnit * fsa.cbSector;
    }
    return((long)(bytes / 1048576UL));
#endif
    return 0;
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
#if 0
static void _Optlink sysload_thread(void *pv)
{
    APIRET rc;
    ULONG tick;
    ULONG last;

    rc = DosSetPriority(PRTYS_THREAD, PRTYC_IDLETIME, PRTYD_MINIMUM, 0);
    if(rc)
        syslog(LOG_ERR, "Error %lu: Can't set priority", rc);
    else {
        rc = DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &last, sizeof(last));
        if(rc)
            syslog(LOG_ERR, "Error %lu: Can't query system tick", rc);
        else {
            for(;;) {
                DosSleep(1000);
                DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &tick, sizeof(tick));
                if(DosEnterCritSec() == 0) {
                    average -= (average >> 5);
                    average += ((tick - last - 1000) >> 5);
                    DosExitCritSec();
                }
                last = tick;
            }
        }
    }
}
#endif

/************************************************************************/
/*                                                                      */
/************************************************************************/
long system_load(void)
{
#if 0
    static int running = 0;
    long result = -1;

    if(DosEnterCritSec() == 0) {
        result = average - 31;
        DosExitCritSec();
        if(!running) {
            _beginthread(sysload_thread, NULL, 32767, NULL);
            running = 1;
        }
    }
    return(result);
#endif
    return 0;
}

/*
 * $Log: ntrescl.c,v $
 * Revision 1.1  1997/02/13 14:03:51  oliver
 * initial revision
 *
 * Revision 1.1  1997/02/13  10:05:51  oliver
 * initial revision
 *
 */
