/*----------------------------------------------------------------------*/
/* Copyright (c) 1996 by Harald Kipp. All rights reserved.              */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/* This software was originally based on the                            */
/*                                                                      */
/*      Network News Transfer Protocol server                           */
/*                                                                      */
/*      Phil Lapsley                                                    */
/*      University of California, Berkeley                              */
/*      Stan Barber                                                     */
/*      Baylor College of Medicine                                      */
/*                                                                      */
/* Send bug reports to                                                  */
/*                                                                      */
/*      harald@os2point.ping.de                                         */
/*                                                                      */
/*----------------------------------------------------------------------*/

const char xpath_rcsid[] = "$Id: xpath.c,v 1.1 1997/02/13 14:04:07 oliver Exp $";

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <process.h>
#include <ctype.h>

#include <syslog.h>

#include <chlimits.h>
#include <sostream.h>
#include <nhistory.h>

#include "globals.h"
#include "nntp.h"
#include "config.h"
#include "client.h"

/************************************************************************/
/*                                                                      */
/* XPATH <messageid>                                                    */
/*                                                                      */
/* Retrieve article's filepath.                                         */
/* This command is an extension, and not included in RFC 977.           */
/*                                                                      */
/************************************************************************/
void xpath(PNEWSCLIENT pnc, int argc, char *argv[])
{
    char *pathlist = malloc(MAX_HISTORYLINE);

    if(pathlistbyid(argv[1], pathlist) == 0) {
        SoStreamPrintf(pnc->s, "%d No article with message-id %s.\r\n",
                  ERR_NOART, argv[1]);
        free(pathlist);
        return;
    }
    SoStreamPrintf(pnc->s, "%d %s\r\n", OK_NOTEXT, pathlist);
    free(pathlist);

    return;
}

/*
 * $Log: xpath.c,v $
 * Revision 1.1  1997/02/13 14:04:07  oliver
 * initial revision
 *
 * Revision 1.1  1997/02/13  10:06:02  oliver
 * initial revision
 *
 */
