const char sodtgram_rcsid[] = "$Id: sodtgram.c,v 1.1 1997/02/13 11:27:32 oliver Exp $";

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef __OS2__

#include <types.h>
#include <netinet\in.h>
#include <sys\socket.h>
#include <netdb.h>
#include <nerrno.h>

#else

#include <winsock.h>

#endif

#include <syslog.h>
#include <sostream.h>
#include <sodtgram.h>

/************************************************************************/
/*                                                                      */
/************************************************************************/
int _Export _System SoDtgramSetServer(char *service, unsigned short defport)
{
    int sock;
    int on = 1;
    unsigned short port;
    struct sockaddr_in server;

    if((sock = SoDtgramOpen()) == -1)
        return(-1);

    /*
     * Determine the port to be used.
     */
    if((port = SoGetServPort((char *)service, "udp")) == -1) {
        port = defport;
        syslog(LOG_INFO, "Unknown service: %s/udp, using port %u", service, port);
    }

    /*
     * Set socket options and bind it.
     */
    if(setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on)))
        syslog(LOG_ERR, "Setting udp socket option failed");

    memset(&server, 0, sizeof(server));
    server.sin_family = AF_INET;
    server.sin_port = htons(port);
    server.sin_addr.s_addr = INADDR_ANY;
    if (bind(sock,  (void *)&server, sizeof(server)) < 0) {
        syslog(LOG_ERR, "Binding udp server socket failed");
        SoDtgramClose(sock);
        return (-1);
    }
    return(sock);
}

/*
 * $Log: sodtgram.c,v $
 * Revision 1.1  1997/02/13 11:27:32  oliver
 * initial revision
 *
 */
