#ifndef CONFIG_H
#define CONFIG_H

/*----------------------------------------------------------------------*/
/* Copyright (c) 1996 by Harald Kipp. All rights reserved.              */
/*                                                                      */
/* Redistribution and use in source and binary forms, with or without   */
/* modification, are permitted provided that the following conditions   */
/* are met:                                                             */
/*                                                                      */
/* 1. Redistributions of source code must retain the above copyright    */
/*    notice, this list of conditions and the following disclaimer.     */
/*                                                                      */
/* 2. Redistributions in binary form must reproduce the above copyright */
/*    notice, this list of conditions and the following disclaimer in   */
/*    the documentation and/or other materials provided with the        */
/*    distribution.                                                     */
/*                                                                      */
/* 3. All advertising materials mentioning features or use of this      */
/*    software must display the following acknowledgment:               */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* 4. The name "Changi Server" must not be used to endorse or promote   */
/*    products derived from this software without prior written         */
/*    permission.                                                       */
/*                                                                      */
/* 5. Redistributions of any form whatsoever must retain the following  */
/*    acknowledgment:                                                   */
/*    "This product includes software developed by Harald Kipp          */
/*    for use in the Changi news server project."                       */
/*                                                                      */
/* ==================================================================== */
/* THIS SOFTWARE IS PROVIDED BY HARALD KIPP ``AS IS'' AND ANY EXPRESSED */
/* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED    */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   */
/* ARE DISCLAIMED. IN NO EVENT SHALL HARALD KIPP BE LIABLE FOR ANY      */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL   */
/* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE    */
/* GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS        */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER */
/* IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR      */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN  */
/* IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                        */
/* ==================================================================== */
/*                                                                      */
/*----------------------------------------------------------------------*/

/*
 * $Id$
 */

/*----------------------------------------------------------------------*/
/*  Configuration                                                       */
/*                                                                      */
/*----------------------------------------------------------------------*/
typedef struct {
    char workdir[_MAX_PATH];
    char mydomain[MAX_DOMAINNAME];  /* local node name including domain */
    char remoteaddr[MAX_DOMAINNAME];
    char remoteport[128];
    char newsfile[_MAX_PATH];       /* article file if not stdin */
    unsigned long logflg;           /* debugging flags */
    long sockwait;                  /* timeout for offer reply */
    int  del_input;
    char authentication[MAX_CLPSIZE]; /* user and password */
    char auth_user[MAX_CLPSIZE];    /* user id */
    char auth_pass[MAX_CLPSIZE];    /* password */
    char logname[MAX_CLPSIZE];      /* added 08/07/1996 harald */
    char realname[MAX_CLPSIZE];     /* added 08/07/1996 harald */
} CONFIG;

extern CONFIG cfg;

extern void init_cfg(void);
extern int validate_cfg(void);

/*----------------------------------------------------------------------*/
/*  Logging flags                                                       */
/*----------------------------------------------------------------------*/
#define LOG_READ    0x00000002L
#define LOG_WRITE   0x00000004L
#define LOG_HISTORY 0x00000008L
#define LOG_HEAP    0x00000010L
#define LOG_TEST    0x00000020L
#define LOG_JUNK    0x00000040L
#define LOG_DUPES   0x00000080L
#define LOG_CONFIG  0x00000100L

#define DOLOG(x)    ((cfg.logflg & (x)) != 0)

/*
 * $Log$
 */

#endif
