// $Id$
//
// $Log$
//

import java.awt.*;

public class ParameterDialog extends Dialog
   {
   Button okButton;
   Button cancelButton;
   MultiLineLabel label;
   protected TextField[] paramValueFields;

   public ParameterDialog(Frame parent, String title, String message,
                          String[] paramName, String[] paramValue)
      {
      super(parent, title, true);

      Panel p0 = new Panel();
      p0.setLayout(new GridBagLayout());
      Constrain c = new Constrain(p0);
      paramValueFields = new TextField[paramName.length];

      c.add( label = new MultiLineLabel(message,20,20),0,0,2,1,GridBagConstraints.BOTH,GridBagConstraints.NORTH,1.0,1.0,5,5,0,5);

      for (int i = 0; i<paramName.length; i++)
         {
         c.add( new Label(paramName[i]),0,1+i,1,1,5,5,0,5);
         paramValueFields[i] = new TextField(paramValue[i].length());
         paramValueFields[i].setText(paramValue[i]);
         c.add( paramValueFields[i],1,1+i,1,1,GridBagConstraints.HORIZONTAL,GridBagConstraints.NORTHWEST,1,0,5,0,0,5);
         }

      Panel p = new Panel();
      p.setLayout(new FlowLayout(FlowLayout.CENTER,15,15));
      p.add(okButton = new Button(Resource.ok));
      p.add(cancelButton = new Button(Resource.cancel));

      this.add("Center",p0);
      this.add("South",p);
      this.pack();
      Rectangle b = parent.bounds();
      reshape( b.x + b.width/2 - 150,
               b.y + b.height/2 - size().height/2,
               size().width<300 ? 300 : size().width,
               size().height );
      }

   public boolean action(Event e, Object arg)
      {
      if (e.target instanceof Button || e.target instanceof TextField)
         {
         if (e.target == okButton || e.target instanceof TextField)
            doit();
         this.hide();
         this.dispose();
         return true;
         }
      else return false;
      }

   public boolean handleEvent(Event e)
      {
      if( (e.id==Event.WINDOW_DESTROY) && (e.target == this) )
         {
         this.hide();
         this.dispose();
         return true;
         }
      else
         return super.handleEvent(e);
      }

   public void doit()
      {
      }

   }
