// $Id$
//
// $Log$
//

import java.net.*;
import java.io.*;
import java.util.*;

public class PollThread extends Thread
   {
   private static final int MAX_BUFFER = 1024;

   private MainWin mainWin;
   private DatagramSocket socket;

   public PollThread(MainWin mainWin)
      {
      this.mainWin = mainWin;
      try { socket = new DatagramSocket(); }
      catch (SocketException e) { mainWin.addToLog("Socket open failed"); }
      }

   public void run()
      {
      if (socket == null)
         return;

      for (;;)
         {
         // Serverstatus feststellen
         String[] s = {mainWin.getUser(),"s"};
         String ret = UDPSocket.transact(s, mainWin.getHost(), mainWin.getPort());
         if (ret == null || ret.equals(""))
            mainWin.setState(MainWin.SERVER_NOT_CONNECTED);
         else
            {
            if (ret.indexOf("flushed") != -1)
               {
               mainWin.setState(MainWin.SERVER_FLUSHED);
               mainWin.reason = ret.substring(ret.indexOf(",")+2);
               mainWin.repaint();
               }
            else if (ret.indexOf("paused") != -1)
               {
               mainWin.setState(MainWin.SERVER_PAUSED);
               mainWin.reason = ret.substring(ret.indexOf(",")+2);
               mainWin.repaint();
               }
            else if (ret.indexOf("throttled") != -1)
               {
               mainWin.setState(MainWin.SERVER_THROTTLED);
               mainWin.reason = ret.substring(ret.indexOf(",")+2);
               mainWin.repaint();
               }
            else mainWin.setState(MainWin.SERVER_RUNNING);

            String[] s1 = {mainWin.getUser(),"R","sysload"};
            ret = UDPSocket.transact(s1, mainWin.getHost(), mainWin.getPort());
            if (ret != null && ret.startsWith("0"))
               mainWin.sysload.setText(ret.substring(2));
            else
               mainWin.sysload.setText("");

            s1[2] = "news";
            ret = UDPSocket.transact(s1, mainWin.getHost(), mainWin.getPort());
            if (ret != null && ret.startsWith("0"))
               mainWin.news.setText(ret.substring(2));
            else
               mainWin.news.setText("");

            s1[2] = "overview";
            ret = UDPSocket.transact(s1, mainWin.getHost(), mainWin.getPort());
            if (ret != null && ret.startsWith("0"))
               mainWin.overview.setText(ret.substring(2));
            else
               mainWin.overview.setText("");

            s1[2] = "history";
            ret = UDPSocket.transact(s1, mainWin.getHost(), mainWin.getPort());
            if (ret != null && ret.startsWith("0"))
               mainWin.history.setText(ret.substring(2));
            else
               mainWin.history.setText("");

            s1[2] = "memory";
            ret = UDPSocket.transact(s1, mainWin.getHost(), mainWin.getPort());
            if (ret != null && ret.startsWith("0"))
               mainWin.memory.setText(ret.substring(2));
            else
               mainWin.memory.setText("");


            // Connected Hosts abfragen
            int index = 0;
            boolean refresh = false;
            Vector hosts = new Vector();
            for (;;)
               {
               String[] H = {mainWin.getUser(),"H",Integer.toString(index)};
               ret = UDPSocket.transact(H, mainWin.getHost(), mainWin.getPort());
               if ( ret.startsWith("0") )
                  {
                  hosts.addElement(ret.substring(2));
                  if (mainWin.hostList.countItems() < index+1 ||
                     !mainWin.hostList.getItem(index).equals(ret.substring(2)))
                     refresh = true;
                  }
               else
                  break;
               index++;
               }
            if (refresh || mainWin.hostList.countItems() != index)
               {
               mainWin.hostList.clear();
               for (Enumeration enum = hosts.elements(); enum.hasMoreElements(); )
                  mainWin.hostList.addItem((String)enum.nextElement());
               }

            // Connected Users abfragen
            index = 0;
            refresh = false;
            Vector users = new Vector();
            for (;;)
               {
               String[] U = {mainWin.getUser(),"U",Integer.toString(index)};
               ret = UDPSocket.transact(U, mainWin.getHost(), mainWin.getPort());
               if ( ret.startsWith("0") )
                  {
                  users.addElement(ret.substring(2));
                  if (mainWin.userList.countItems() < index+1 ||
                      !mainWin.userList.getItem(index).equals(ret.substring(2)))
                     refresh = true;
                  }
               else
                  break;
               index++;
               }
            if (refresh || mainWin.userList.countItems() != index)
               {
               mainWin.userList.clear();
               for (Enumeration enum = users.elements(); enum.hasMoreElements(); )
                  mainWin.userList.addItem((String)enum.nextElement());
               }

            }
         try {sleep(mainWin.getSleep()*1000);} catch (InterruptedException e) {}
         }
      }
   }
