// $Id$
//
// $Log$
//

import java.net.*;
import java.io.*;

public class UDPSocket
   {
   public static final int MAX_BUFFER = 1024;

   public static void send(String command[], String host, int port)
      {
      if (command.length > 0)
         {
         int length = command.length-1;
         for(int i=0; i<command.length; i++)
            length += command[i].length();

         byte buffer[] = new byte[length];
         int index = 0;

         for(int i=0; i<command.length; i++)
            {
            command[i].getBytes(0,command[i].length(), buffer, index);
            index += command[i].length();
            if (i < command.length-1)
               {
               buffer[index] = 1;
               index++;
               }
            }
         try
            {
            DatagramSocket socket = new DatagramSocket();
            DatagramPacket packet = new DatagramPacket( buffer, buffer.length,
                                        InetAddress.getByName(host), port );

//            System.err.println(packet.getAddress().getHostName()+
//               ":"+packet.getPort()+" << "+new String(buffer,0,0,packet.getLength()));
            socket.send(packet);
            socket.close();
            }
         catch (SocketException e)      { System.err.println("Socket open failed"); }
         catch (UnknownHostException e) { System.err.println("Unknown Host"); }
         catch (IOException e)          { System.err.println("send failed"); }
         }
     }

    public static String transact(String command[], String host, int port)
      {
      String s = null;
      if (command.length > 0)
         {
         int length = command.length-1;
         for(int i=0; i<command.length; i++)
            if (command[i] != null)
               length += command[i].length();

         byte buffer[] = new byte[length];
         int index = 0;

         for(int i=0; i<command.length; i++)
            {
            if (command[i] != null)
               {
               command[i].getBytes(0,command[i].length(), buffer, index);
               index += command[i].length();
               }
            if (i < command.length-1)
               {
               buffer[index] = 1;
               index++;
               }
            }
         try
            {
            DatagramSocket socket = new DatagramSocket();
            DatagramPacket packet = new DatagramPacket( buffer, buffer.length,
                                        InetAddress.getByName(host), port );

//            System.err.println(packet.getAddress().getHostName()+
//               ":"+packet.getPort()+" << "+new String(buffer,0,0,packet.getLength()));
            socket.send(packet);

            buffer = new byte[UDPSocket.MAX_BUFFER];
            packet = new DatagramPacket(buffer, buffer.length);

            UDPObserveThread obsrvThread = new UDPObserveThread(socket, 5000);
            obsrvThread.start();
            try { socket.receive(packet);} catch (IOException e) {}
            obsrvThread.stop();

            s = new String(buffer,0,0,packet.getLength());
//            System.err.println(packet.getAddress().getHostName()+
//               ":"+packet.getPort()+" >> "+s);

            socket.close();
            }
         catch (SocketException e)      { System.err.println("Socket open failed"); }
         catch (UnknownHostException e) { System.err.println("Unknown Host"); }
         catch (IOException e)          { System.err.println("send failed"); }
         }
      return s;
      }

   }

class UDPObserveThread extends Thread
   {
   DatagramSocket socket;
   long wait;

   UDPObserveThread(DatagramSocket socket, long wait)
      {
      this.socket = socket;
      this.wait = wait;
      }

   public void run()
      {
      try {sleep(wait);} catch (InterruptedException e) {};
      byte[] buffer = new byte[1];
      try
         {
         DatagramPacket packet = new DatagramPacket( buffer, 0, InetAddress.getLocalHost(), socket.getLocalPort() );
         socket.send(packet);
         }
      catch (UnknownHostException e) { }
      catch (IOException e)          { }
      }

   }
